var require, define;
(function () {
    var loadingMap = {};
    var factoryMap = {};
    var modulesMap = {};

    define = function (id, factory) {
        id = id.replace(/\.js$/i, '');
        factoryMap[id] = factory;

        var queue = loadingMap[id];
        if (queue) {
            for (var i = 0, n = queue.length; i < n; i++) {
                queue[i]();
            }
            delete loadingMap[id];
        }
    };

    require = function (id) {
        id = require.alias(id);

        var mod = modulesMap[id];
        if (mod) {
            return mod.exports;
        }

        var factory = factoryMap[id];
        if (!factory) {
            throw '[ModJS] Cannot find module `' + id + '`';
        }

        mod = modulesMap[id] = {
            exports: {}
        };

        var ret = (typeof factory === 'function') ? factory.apply(mod, [require, mod.exports, mod]) : factory;

        if (ret) {
            mod.exports = ret;
        }

        return mod.exports;
    };

    require.alias = function (id) {
        return id.replace(/\.js$/i, '');
    };
})(this);
/**! node_modules/monaco-editor/esm/vs/base/common/linkedList.js*/
define("45886bc",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;var n=e("6ad26fe"),i=function(){function e(t){this.element=t,this.next=e.Undefined,this.prev=e.Undefined}return e.Undefined=new e(void 0),e}(),r=function(){function e(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return this._first===i.Undefined},e.prototype.clear=function(){this._first=i.Undefined,this._last=i.Undefined,this._size=0},e.prototype.unshift=function(e){return this._insert(e,!1)},e.prototype.push=function(e){return this._insert(e,!0)},e.prototype._insert=function(e,t){var n=this,r=new i(e);if(this._first===i.Undefined)this._first=r,this._last=r;else if(t){var s=this._last;this._last=r,r.prev=s,s.next=r}else{var f=this._first;this._first=r,r.next=f,f.prev=r}this._size+=1;var d=!1;return function(){d||(d=!0,n._remove(r))}},e.prototype.shift=function(){if(this._first===i.Undefined)return void 0;var e=this._first.element;return this._remove(this._first),e},e.prototype._remove=function(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){var t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1},e.prototype.iterator=function(){var e,t=this._first;return{next:function(){return t===i.Undefined?n.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}},e.prototype.toArray=function(){for(var e=[],t=this._first;t!==i.Undefined;t=t.next)e.push(t.element);return e},e}();t.LinkedList=r});
/**! node_modules/monaco-editor/esm/vs/base/common/functional.js*/
define("4af2228",function(e,n){"use strict";function t(e){var n,t=this,i=!1;return function(){return i?n:(i=!0,n=e.apply(t,arguments))}}Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0,n.once=t});
/**! node_modules/monaco-editor/esm/vs/base/common/linkedList.js*/
define("45886bc",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;var n=e("6ad26fe"),i=function(){function e(t){this.element=t,this.next=e.Undefined,this.prev=e.Undefined}return e.Undefined=new e(void 0),e}(),r=function(){function e(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}return Object.defineProperty(e.prototype,"size",{get:function(){return this._size},enumerable:!0,configurable:!0}),e.prototype.isEmpty=function(){return this._first===i.Undefined},e.prototype.clear=function(){this._first=i.Undefined,this._last=i.Undefined,this._size=0},e.prototype.unshift=function(e){return this._insert(e,!1)},e.prototype.push=function(e){return this._insert(e,!0)},e.prototype._insert=function(e,t){var n=this,r=new i(e);if(this._first===i.Undefined)this._first=r,this._last=r;else if(t){var s=this._last;this._last=r,r.prev=s,s.next=r}else{var f=this._first;this._first=r,r.next=f,f.prev=r}this._size+=1;var d=!1;return function(){d||(d=!0,n._remove(r))}},e.prototype.shift=function(){if(this._first===i.Undefined)return void 0;var e=this._first.element;return this._remove(this._first),e},e.prototype._remove=function(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){var t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1},e.prototype.iterator=function(){var e,t=this._first;return{next:function(){return t===i.Undefined?n.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}},e.prototype.toArray=function(){for(var e=[],t=this._first;t!==i.Undefined;t=t.next)e.push(t.element);return e},e}();t.LinkedList=r});
/**! node_modules/monaco-editor/esm/vs/base/common/functional.js*/
define("4af2228",function(e,n){"use strict";function t(e){var n,t=this,i=!1;return function(){return i?n:(i=!0,n=e.apply(t,arguments))}}Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0,n.once=t});
/**! node_modules/monaco-editor/esm/vs/base/common/event.js*/
define("8451667",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.Event=void 0;var n=this&&this.__extends||function(){var t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};return function(e,n){function i(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(i.prototype=n.prototype,new i)}}(),i=t("22e50b6"),r=t("4af2228"),o=t("a0b8cca"),s=t("45886bc");!function(t){function e(t){return function(e,n,i){void 0===n&&(n=null);var r,o=!1;return r=t(function(t){return o?void 0:(r?r.dispose():o=!0,e.call(n,t))},null,i),o&&r.dispose(),r}}function n(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return n.call(i,e(t))},null,r)})}function i(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){e(t),n.call(i,t)},null,r)})}function r(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return e(t)&&n.call(i,t)},null,r)})}function s(t){return t}function u(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return function(e,n,i){return void 0===n&&(n=null),o.combinedDisposable(t.map(function(t){return t(function(t){return e.call(n,t)},null,i)}))}}function c(t,e,i){var r=i;return n(t,function(t){return r=e(r,t)})}function a(t){var e,n=new f({onFirstListenerAdd:function(){e=t(n.fire,n)},onLastListenerRemove:function(){e.dispose()}});return n.event}function h(t,e,n,i,r){void 0===n&&(n=100),void 0===i&&(i=!1);var o,s=void 0,u=void 0,c=0,a=new f({leakWarningThreshold:r,onFirstListenerAdd:function(){o=t(function(t){c++,s=e(s,t),i&&!u&&a.fire(s),clearTimeout(u),u=setTimeout(function(){var t=s;s=void 0,u=void 0,(!i||c>1)&&a.fire(t),c=0},n)})},onLastListenerRemove:function(){o.dispose()}});return a.event}function p(t){var i=(new Date).getTime();return n(e(t),function(){return(new Date).getTime()-i})}function v(t){var e,n=!0;return r(t,function(t){var i=n||t!==e;return n=!1,e=t,i})}function l(t,e,n){void 0===e&&(e=!1),void 0===n&&(n=[]);var i=n.slice(),r=t(function(t){i?i.push(t):s.fire(t)}),o=function(){i&&i.forEach(function(t){return s.fire(t)}),i=null},s=new f({onFirstListenerAdd:function(){r||(r=t(function(t){return s.fire(t)}))},onFirstListenerDidAdd:function(){i&&(e?setTimeout(o):o())},onLastListenerRemove:function(){r&&r.dispose(),r=null}});return s.event}function d(t){return new E(t)}function _(t,e,n){void 0===n&&(n=function(t){return t});var i=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return s.fire(n.apply(void 0,t))},r=function(){return t.on(e,i)},o=function(){return t.removeListener(e,i)},s=new f({onFirstListenerAdd:r,onLastListenerRemove:o});return s.event}function m(t){var e=new f,n=!1;return t.then(void 0,function(){return null}).then(function(){n?e.fire(void 0):setTimeout(function(){return e.fire(void 0)},0)}),n=!0,e.event}function y(t){return new Promise(function(n){return e(t)(n)})}var L={dispose:function(){}};t.None=function(){return L},t.once=e,t.map=n,t.forEach=i,t.filter=r,t.signal=s,t.any=u,t.reduce=c,t.snapshot=a,t.debounce=h,t.stopwatch=p,t.latch=v,t.buffer=l;var E=function(){function t(t){this.event=t}return t.prototype.map=function(e){return new t(n(this.event,e))},t.prototype.forEach=function(e){return new t(i(this.event,e))},t.prototype.filter=function(e){return new t(r(this.event,e))},t.prototype.reduce=function(e,n){return new t(c(this.event,e,n))},t.prototype.latch=function(){return new t(v(this.event))},t.prototype.on=function(t,e,n){return this.event(t,e,n)},t.prototype.once=function(t,n,i){return e(this.event)(t,n,i)},t}();t.chain=d,t.fromNodeEventEmitter=_,t.fromPromise=m,t.toPromise=y}(e.Event||(e.Event={}));var u=-1,c=function(){function t(t,e){void 0===e&&(e=Math.random().toString(18).slice(2,5)),this.customThreshold=t,this.name=e,this._warnCountdown=0}return t.prototype.dispose=function(){this._stacks&&this._stacks.clear()},t.prototype.check=function(t){var e=this,n=u;if("number"==typeof this.customThreshold&&(n=this.customThreshold),0>=n||n>t)return void 0;this._stacks||(this._stacks=new Map);var i=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(i)||0;if(this._stacks.set(i,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=.5*n;var o,s=0;this._stacks.forEach(function(t,e){(!o||t>s)&&(o=e,s=t)}),console.warn("["+this.name+"] potential listener LEAK detected, having "+t+" listeners already. MOST frequent listener ("+s+"):"),console.warn(o)}return function(){var t=e._stacks.get(i)||0;e._stacks.set(i,t-1)}},t}(),f=function(){function t(t){this._disposed=!1,this._options=t,this._leakageMon=u>0?new c(this._options&&this._options.leakWarningThreshold):void 0}return Object.defineProperty(t.prototype,"event",{get:function(){var e=this;return this._event||(this._event=function(n,i,r){e._listeners||(e._listeners=new s.LinkedList);var o=e._listeners.isEmpty();o&&e._options&&e._options.onFirstListenerAdd&&e._options.onFirstListenerAdd(e);var u=e._listeners.push(i?[n,i]:n);o&&e._options&&e._options.onFirstListenerDidAdd&&e._options.onFirstListenerDidAdd(e),e._options&&e._options.onListenerDidAdd&&e._options.onListenerDidAdd(e,n,i);var c;e._leakageMon&&(c=e._leakageMon.check(e._listeners.size));var f;return f={dispose:function(){if(c&&c(),f.dispose=t._noop,!e._disposed&&(u(),e._options&&e._options.onLastListenerRemove)){var n=e._listeners&&!e._listeners.isEmpty();n||e._options.onLastListenerRemove(e)}}},Array.isArray(r)&&r.push(f),f}),this._event},enumerable:!0,configurable:!0}),t.prototype.fire=function(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(var e=this._listeners.iterator(),n=e.next();!n.done;n=e.next())this._deliveryQueue.push([n.value,t]);for(;this._deliveryQueue.size>0;){var r=this._deliveryQueue.shift(),o=r[0],u=r[1];try{"function"==typeof o?o.call(void 0,u):o[0].call(o[1],u)}catch(n){i.onUnexpectedError(n)}}}},t.prototype.dispose=function(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0},t._noop=function(){},t}();e.Emitter=f;var a=function(t){function e(e){var n=t.call(this,e)||this;return n._isPaused=0,n._eventQueue=new s.LinkedList,n._mergeFn=e&&e.merge,n}return n(e,t),e.prototype.pause=function(){this._isPaused++},e.prototype.resume=function(){if(0!==this._isPaused&&0===--this._isPaused)if(this._mergeFn){var e=this._eventQueue.toArray();this._eventQueue.clear(),t.prototype.fire.call(this,this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)t.prototype.fire.call(this,this._eventQueue.shift())},e.prototype.fire=function(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):t.prototype.fire.call(this,e))},e}(f);e.PauseableEmitter=a;var h=function(){function t(){var t=this;this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:function(){return t.onFirstListenerAdd()},onLastListenerRemove:function(){return t.onLastListenerRemove()}})}return Object.defineProperty(t.prototype,"event",{get:function(){return this.emitter.event},enumerable:!0,configurable:!0}),t.prototype.add=function(t){var e=this,n={event:t,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);var i=function(){e.hasListeners&&e.unhook(n);var t=e.events.indexOf(n);e.events.splice(t,1)};return o.toDisposable(r.once(i))},t.prototype.onFirstListenerAdd=function(){var t=this;this.hasListeners=!0,this.events.forEach(function(e){return t.hook(e)})},t.prototype.onLastListenerRemove=function(){var t=this;this.hasListeners=!1,this.events.forEach(function(e){return t.unhook(e)})},t.prototype.hook=function(t){var e=this;t.listener=t.event(function(t){return e.emitter.fire(t)})},t.prototype.unhook=function(t){t.listener&&t.listener.dispose(),t.listener=null},t.prototype.dispose=function(){this.emitter.dispose()},t}();e.EventMultiplexer=h;var p=function(){function t(){this.buffers=[]}return t.prototype.wrapEvent=function(t){var e=this;return function(n,i,r){return t(function(t){var r=e.buffers[e.buffers.length-1];r?r.push(function(){return n.call(i,t)}):n.call(i,t)},void 0,r)}},t.prototype.bufferEvents=function(t){var e=[];this.buffers.push(e);var n=t();return this.buffers.pop(),e.forEach(function(t){return t()}),n},t}();e.EventBufferer=p;var v=function(){function t(){var t=this;this.listening=!1,this.inputEvent=e.Event.None,this.inputEventListener=o.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:function(){t.listening=!0,t.inputEventListener=t.inputEvent(t.emitter.fire,t.emitter)},onLastListenerRemove:function(){t.listening=!1,t.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(t.prototype,"input",{set:function(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},t}();e.Relay=v});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/uint.js*/
define("4186ef1",function(t,n){"use strict";function i(t){return 0>t?0:t>255?255:0|t}function r(t){return 0>t?0:t>4294967295?4294967295:0|t}function o(t){for(var n=t.length,i=new Uint32Array(n),o=0;n>o;o++)i[o]=r(t[o]);return i}Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32Array=n.toUint32=n.toUint8=n.Uint8Matrix=void 0;var e=function(){function t(t,n,i){for(var r=new Uint8Array(t*n),o=0,e=t*n;e>o;o++)r[o]=i;this._data=r,this.rows=t,this.cols=n}return t.prototype.get=function(t,n){return this._data[t*this.cols+n]},t.prototype.set=function(t,n,i){this._data[t*this.cols+n]=i},t}();n.Uint8Matrix=e,n.toUint8=i,n.toUint32=r,n.toUint32Array=o});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/uint.js*/
define("4186ef1",function(t,n){"use strict";function i(t){return 0>t?0:t>255?255:0|t}function r(t){return 0>t?0:t>4294967295?4294967295:0|t}function o(t){for(var n=t.length,i=new Uint32Array(n),o=0;n>o;o++)i[o]=r(t[o]);return i}Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32Array=n.toUint32=n.toUint8=n.Uint8Matrix=void 0;var e=function(){function t(t,n,i){for(var r=new Uint8Array(t*n),o=0,e=t*n;e>o;o++)r[o]=i;this._data=r,this.rows=t,this.cols=n}return t.prototype.get=function(t,n){return this._data[t*this.cols+n]},t.prototype.set=function(t,n,i){this._data[t*this.cols+n]=i},t}();n.Uint8Matrix=e,n.toUint8=i,n.toUint32=r,n.toUint32Array=o});
/**! node_modules/monaco-editor/esm/vs/editor/common/standalone/standaloneEnums.js*/
define("2e266ae",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SymbolKind=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.CompletionTriggerKind=n.CompletionItemInsertTextRule=n.CompletionItemKind=n.IndentAction=n.MouseTargetType=n.OverlayWidgetPositionPreference=n.ContentWidgetPositionPreference=n.RenderLineNumbersType=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.WrappingIndent=n.RenderMinimap=n.CursorChangeReason=n.ScrollType=n.TrackedRangeStickiness=n.EndOfLineSequence=n.DefaultEndOfLine=n.EndOfLinePreference=n.OverviewRulerLane=n.ScrollbarVisibility=n.SelectionDirection=n.KeyCode=n.MarkerSeverity=n.MarkerTag=void 0,function(e){e[e.Unnecessary=1]="Unnecessary"}(n.MarkerTag||(n.MarkerTag={})),function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"}(n.MarkerSeverity||(n.MarkerSeverity={})),function(e){e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.KEY_0=21]="KEY_0",e[e.KEY_1=22]="KEY_1",e[e.KEY_2=23]="KEY_2",e[e.KEY_3=24]="KEY_3",e[e.KEY_4=25]="KEY_4",e[e.KEY_5=26]="KEY_5",e[e.KEY_6=27]="KEY_6",e[e.KEY_7=28]="KEY_7",e[e.KEY_8=29]="KEY_8",e[e.KEY_9=30]="KEY_9",e[e.KEY_A=31]="KEY_A",e[e.KEY_B=32]="KEY_B",e[e.KEY_C=33]="KEY_C",e[e.KEY_D=34]="KEY_D",e[e.KEY_E=35]="KEY_E",e[e.KEY_F=36]="KEY_F",e[e.KEY_G=37]="KEY_G",e[e.KEY_H=38]="KEY_H",e[e.KEY_I=39]="KEY_I",e[e.KEY_J=40]="KEY_J",e[e.KEY_K=41]="KEY_K",e[e.KEY_L=42]="KEY_L",e[e.KEY_M=43]="KEY_M",e[e.KEY_N=44]="KEY_N",e[e.KEY_O=45]="KEY_O",e[e.KEY_P=46]="KEY_P",e[e.KEY_Q=47]="KEY_Q",e[e.KEY_R=48]="KEY_R",e[e.KEY_S=49]="KEY_S",e[e.KEY_T=50]="KEY_T",e[e.KEY_U=51]="KEY_U",e[e.KEY_V=52]="KEY_V",e[e.KEY_W=53]="KEY_W",e[e.KEY_X=54]="KEY_X",e[e.KEY_Y=55]="KEY_Y",e[e.KEY_Z=56]="KEY_Z",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.US_SEMICOLON=80]="US_SEMICOLON",e[e.US_EQUAL=81]="US_EQUAL",e[e.US_COMMA=82]="US_COMMA",e[e.US_MINUS=83]="US_MINUS",e[e.US_DOT=84]="US_DOT",e[e.US_SLASH=85]="US_SLASH",e[e.US_BACKTICK=86]="US_BACKTICK",e[e.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",e[e.US_BACKSLASH=88]="US_BACKSLASH",e[e.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",e[e.US_QUOTE=90]="US_QUOTE",e[e.OEM_8=91]="OEM_8",e[e.OEM_102=92]="OEM_102",e[e.NUMPAD_0=93]="NUMPAD_0",e[e.NUMPAD_1=94]="NUMPAD_1",e[e.NUMPAD_2=95]="NUMPAD_2",e[e.NUMPAD_3=96]="NUMPAD_3",e[e.NUMPAD_4=97]="NUMPAD_4",e[e.NUMPAD_5=98]="NUMPAD_5",e[e.NUMPAD_6=99]="NUMPAD_6",e[e.NUMPAD_7=100]="NUMPAD_7",e[e.NUMPAD_8=101]="NUMPAD_8",e[e.NUMPAD_9=102]="NUMPAD_9",e[e.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",e[e.NUMPAD_ADD=104]="NUMPAD_ADD",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",e[e.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",e[e.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.MAX_VALUE=112]="MAX_VALUE"}(n.KeyCode||(n.KeyCode={})),function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"}(n.SelectionDirection||(n.SelectionDirection={})),function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"}(n.ScrollbarVisibility||(n.ScrollbarVisibility={})),function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"}(n.OverviewRulerLane||(n.OverviewRulerLane={})),function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(n.EndOfLinePreference||(n.EndOfLinePreference={})),function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(n.DefaultEndOfLine||(n.DefaultEndOfLine={})),function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"}(n.EndOfLineSequence||(n.EndOfLineSequence={})),function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}(n.TrackedRangeStickiness||(n.TrackedRangeStickiness={})),function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"}(n.ScrollType||(n.ScrollType={})),function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"}(n.CursorChangeReason||(n.CursorChangeReason={})),function(e){e[e.None=0]="None",e[e.Small=1]="Small",e[e.Large=2]="Large",e[e.SmallBlocks=3]="SmallBlocks",e[e.LargeBlocks=4]="LargeBlocks"}(n.RenderMinimap||(n.RenderMinimap={})),function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"}(n.WrappingIndent||(n.WrappingIndent={})),function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"}(n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={})),function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"}(n.TextEditorCursorStyle||(n.TextEditorCursorStyle={})),function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"}(n.RenderLineNumbersType||(n.RenderLineNumbersType={})),function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"}(n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={})),function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"}(n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={})),function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"}(n.MouseTargetType||(n.MouseTargetType={})),function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"}(n.IndentAction||(n.IndentAction={})),function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.Snippet=25]="Snippet"}(n.CompletionItemKind||(n.CompletionItemKind={})),function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"}(n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={})),function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}(n.CompletionTriggerKind||(n.CompletionTriggerKind={})),function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={})),function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(n.DocumentHighlightKind||(n.DocumentHighlightKind={})),function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"}(n.SymbolKind||(n.SymbolKind={}))});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/token.js*/
define("57d67ff",function(t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationResult2=n.TokenizationResult=n.Token=void 0;var e=function(){function t(t,n,e){this.offset=0|t,this.type=n,this.language=e}return t.prototype.toString=function(){return"("+this.offset+", "+this.type+")"},t}();n.Token=e;var i=function(){function t(t,n){this.tokens=t,this.endState=n}return t}();n.TokenizationResult=i;var o=function(){function t(t,n){this.tokens=t,this.endState=n}return t}();n.TokenizationResult2=o});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/selection.js*/
define("3b7eb07",function(t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;var e=this&&this.__extends||function(){var t=function(n,e){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,n){t.__proto__=n}||function(t,n){for(var e in n)n.hasOwnProperty(e)&&(t[e]=n[e])})(n,e)};return function(n,e){function i(){this.constructor=n}t(n,e),n.prototype=null===e?Object.create(e):(i.prototype=e.prototype,new i)}}(),i=t("5ddf902"),o=t("4661130"),r=function(t){function n(n,e,i,o){var r=t.call(this,n,e,i,o)||this;return r.selectionStartLineNumber=n,r.selectionStartColumn=e,r.positionLineNumber=i,r.positionColumn=o,r}return e(n,t),n.prototype.clone=function(){return new n(this.selectionStartLineNumber,this.selectionStartColumn,this.positionLineNumber,this.positionColumn)},n.prototype.toString=function(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"},n.prototype.equalsSelection=function(t){return n.selectionsEqual(this,t)},n.selectionsEqual=function(t,n){return t.selectionStartLineNumber===n.selectionStartLineNumber&&t.selectionStartColumn===n.selectionStartColumn&&t.positionLineNumber===n.positionLineNumber&&t.positionColumn===n.positionColumn},n.prototype.getDirection=function(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1},n.prototype.setEndPosition=function(t,e){return 0===this.getDirection()?new n(this.startLineNumber,this.startColumn,t,e):new n(t,e,this.startLineNumber,this.startColumn)},n.prototype.getPosition=function(){return new i.Position(this.positionLineNumber,this.positionColumn)},n.prototype.setStartPosition=function(t,e){return 0===this.getDirection()?new n(t,e,this.endLineNumber,this.endColumn):new n(this.endLineNumber,this.endColumn,t,e)},n.fromPositions=function(t,e){return void 0===e&&(e=t),new n(t.lineNumber,t.column,e.lineNumber,e.column)},n.liftSelection=function(t){return new n(t.selectionStartLineNumber,t.selectionStartColumn,t.positionLineNumber,t.positionColumn)},n.selectionsArrEqual=function(t,n){if(t&&!n||!t&&n)return!1;if(!t&&!n)return!0;if(t.length!==n.length)return!1;for(var e=0,i=t.length;i>e;e++)if(!this.selectionsEqual(t[e],n[e]))return!1;return!0},n.isISelection=function(t){return t&&"number"==typeof t.selectionStartLineNumber&&"number"==typeof t.selectionStartColumn&&"number"==typeof t.positionLineNumber&&"number"==typeof t.positionColumn},n.createWithDirection=function(t,e,i,o,r){return 0===r?new n(t,e,i,o):new n(i,o,t,e)},n}(o.Range);n.Selection=r});
/**! node_modules/monaco-editor/esm/vs/base/common/keyCodes.js*/
define("651ae9b",function(e,t){"use strict";function n(e,t){var n=(65535&t)<<16>>>0;return(e|n)>>>0}function i(e,t){if(0===e)return null;var n=(65535&e)>>>0,i=(4294901760&e)>>>16;return new h(0!==i?[r(n,t),r(i,t)]:[r(n,t)])}function r(e,t){var n=2048&e?!0:!1,i=256&e?!0:!1,r=2===t?i:n,o=1024&e?!0:!1,s=512&e?!0:!1,u=2===t?n:i,d=255&e;return new y(r,o,s,u,d)}Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=t.KeyChord=t.KeyCodeUtils=void 0;var o=e("22e50b6"),s=function(){function e(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}return e.prototype.define=function(e,t){this._keyCodeToStr[e]=t,this._strToKeyCode[t.toLowerCase()]=e},e.prototype.keyCodeToStr=function(e){return this._keyCodeToStr[e]},e.prototype.strToKeyCode=function(e){return this._strToKeyCode[e.toLowerCase()]||0},e}(),u=new s,d=new s,a=new s;!function(){function e(e,t,n,i){void 0===n&&(n=t),void 0===i&&(i=n),u.define(e,t),d.define(e,n),a.define(e,i)}e(0,"unknown"),e(1,"Backspace"),e(2,"Tab"),e(3,"Enter"),e(4,"Shift"),e(5,"Ctrl"),e(6,"Alt"),e(7,"PauseBreak"),e(8,"CapsLock"),e(9,"Escape"),e(10,"Space"),e(11,"PageUp"),e(12,"PageDown"),e(13,"End"),e(14,"Home"),e(15,"LeftArrow","Left"),e(16,"UpArrow","Up"),e(17,"RightArrow","Right"),e(18,"DownArrow","Down"),e(19,"Insert"),e(20,"Delete"),e(21,"0"),e(22,"1"),e(23,"2"),e(24,"3"),e(25,"4"),e(26,"5"),e(27,"6"),e(28,"7"),e(29,"8"),e(30,"9"),e(31,"A"),e(32,"B"),e(33,"C"),e(34,"D"),e(35,"E"),e(36,"F"),e(37,"G"),e(38,"H"),e(39,"I"),e(40,"J"),e(41,"K"),e(42,"L"),e(43,"M"),e(44,"N"),e(45,"O"),e(46,"P"),e(47,"Q"),e(48,"R"),e(49,"S"),e(50,"T"),e(51,"U"),e(52,"V"),e(53,"W"),e(54,"X"),e(55,"Y"),e(56,"Z"),e(57,"Meta"),e(58,"ContextMenu"),e(59,"F1"),e(60,"F2"),e(61,"F3"),e(62,"F4"),e(63,"F5"),e(64,"F6"),e(65,"F7"),e(66,"F8"),e(67,"F9"),e(68,"F10"),e(69,"F11"),e(70,"F12"),e(71,"F13"),e(72,"F14"),e(73,"F15"),e(74,"F16"),e(75,"F17"),e(76,"F18"),e(77,"F19"),e(78,"NumLock"),e(79,"ScrollLock"),e(80,";",";","OEM_1"),e(81,"=","=","OEM_PLUS"),e(82,",",",","OEM_COMMA"),e(83,"-","-","OEM_MINUS"),e(84,".",".","OEM_PERIOD"),e(85,"/","/","OEM_2"),e(86,"`","`","OEM_3"),e(110,"ABNT_C1"),e(111,"ABNT_C2"),e(87,"[","[","OEM_4"),e(88,"\\","\\","OEM_5"),e(89,"]","]","OEM_6"),e(90,"'","'","OEM_7"),e(91,"OEM_8"),e(92,"OEM_102"),e(93,"NumPad0"),e(94,"NumPad1"),e(95,"NumPad2"),e(96,"NumPad3"),e(97,"NumPad4"),e(98,"NumPad5"),e(99,"NumPad6"),e(100,"NumPad7"),e(101,"NumPad8"),e(102,"NumPad9"),e(103,"NumPad_Multiply"),e(104,"NumPad_Add"),e(105,"NumPad_Separator"),e(106,"NumPad_Subtract"),e(107,"NumPad_Decimal"),e(108,"NumPad_Divide")}(),function(e){function t(e){return u.keyCodeToStr(e)}function n(e){return u.strToKeyCode(e)}function i(e){return d.keyCodeToStr(e)}function r(e){return a.keyCodeToStr(e)}function o(e){return d.strToKeyCode(e)||a.strToKeyCode(e)}e.toString=t,e.fromString=n,e.toUserSettingsUS=i,e.toUserSettingsGeneral=r,e.fromUserSettings=o}(t.KeyCodeUtils||(t.KeyCodeUtils={})),t.KeyChord=n,t.createKeybinding=i,t.createSimpleKeybinding=r;var y=function(){function e(e,t,n,i,r){this.ctrlKey=e,this.shiftKey=t,this.altKey=n,this.metaKey=i,this.keyCode=r}return e.prototype.equals=function(e){return this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode},e.prototype.isModifierKey=function(){return 0===this.keyCode||5===this.keyCode||57===this.keyCode||6===this.keyCode||4===this.keyCode},e.prototype.toChord=function(){return new h([this])},e.prototype.isDuplicateModifierCase=function(){return this.ctrlKey&&5===this.keyCode||this.shiftKey&&4===this.keyCode||this.altKey&&6===this.keyCode||this.metaKey&&57===this.keyCode},e}();t.SimpleKeybinding=y;var h=function(){function e(e){if(0===e.length)throw o.illegalArgument("parts");this.parts=e}return e.prototype.equals=function(e){if(null===e)return!1;if(this.parts.length!==e.parts.length)return!1;for(var t=0;t<this.parts.length;t++)if(!this.parts[t].equals(e.parts[t]))return!1;return!0},e}();t.ChordKeybinding=h;var c=function(){function e(e,t,n,i,r,o){this.ctrlKey=e,this.shiftKey=t,this.altKey=n,this.metaKey=i,this.keyLabel=r,this.keyAriaLabel=o}return e}();t.ResolvedKeybindingPart=c;var f=function(){function e(){}return e}();t.ResolvedKeybinding=f});
/**! node_modules/monaco-editor/esm/vs/base/common/event.js*/
define("8451667",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.Event=void 0;var n=this&&this.__extends||function(){var t=function(e,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])})(e,n)};return function(e,n){function i(){this.constructor=e}t(e,n),e.prototype=null===n?Object.create(n):(i.prototype=n.prototype,new i)}}(),i=t("22e50b6"),r=t("4af2228"),o=t("a0b8cca"),s=t("45886bc");!function(t){function e(t){return function(e,n,i){void 0===n&&(n=null);var r,o=!1;return r=t(function(t){return o?void 0:(r?r.dispose():o=!0,e.call(n,t))},null,i),o&&r.dispose(),r}}function n(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return n.call(i,e(t))},null,r)})}function i(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){e(t),n.call(i,t)},null,r)})}function r(t,e){return a(function(n,i,r){return void 0===i&&(i=null),t(function(t){return e(t)&&n.call(i,t)},null,r)})}function s(t){return t}function u(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return function(e,n,i){return void 0===n&&(n=null),o.combinedDisposable(t.map(function(t){return t(function(t){return e.call(n,t)},null,i)}))}}function c(t,e,i){var r=i;return n(t,function(t){return r=e(r,t)})}function a(t){var e,n=new f({onFirstListenerAdd:function(){e=t(n.fire,n)},onLastListenerRemove:function(){e.dispose()}});return n.event}function h(t,e,n,i,r){void 0===n&&(n=100),void 0===i&&(i=!1);var o,s=void 0,u=void 0,c=0,a=new f({leakWarningThreshold:r,onFirstListenerAdd:function(){o=t(function(t){c++,s=e(s,t),i&&!u&&a.fire(s),clearTimeout(u),u=setTimeout(function(){var t=s;s=void 0,u=void 0,(!i||c>1)&&a.fire(t),c=0},n)})},onLastListenerRemove:function(){o.dispose()}});return a.event}function p(t){var i=(new Date).getTime();return n(e(t),function(){return(new Date).getTime()-i})}function v(t){var e,n=!0;return r(t,function(t){var i=n||t!==e;return n=!1,e=t,i})}function l(t,e,n){void 0===e&&(e=!1),void 0===n&&(n=[]);var i=n.slice(),r=t(function(t){i?i.push(t):s.fire(t)}),o=function(){i&&i.forEach(function(t){return s.fire(t)}),i=null},s=new f({onFirstListenerAdd:function(){r||(r=t(function(t){return s.fire(t)}))},onFirstListenerDidAdd:function(){i&&(e?setTimeout(o):o())},onLastListenerRemove:function(){r&&r.dispose(),r=null}});return s.event}function d(t){return new E(t)}function _(t,e,n){void 0===n&&(n=function(t){return t});var i=function(){for(var t=[],e=0;e<arguments.length;e++)t[e]=arguments[e];return s.fire(n.apply(void 0,t))},r=function(){return t.on(e,i)},o=function(){return t.removeListener(e,i)},s=new f({onFirstListenerAdd:r,onLastListenerRemove:o});return s.event}function m(t){var e=new f,n=!1;return t.then(void 0,function(){return null}).then(function(){n?e.fire(void 0):setTimeout(function(){return e.fire(void 0)},0)}),n=!0,e.event}function y(t){return new Promise(function(n){return e(t)(n)})}var L={dispose:function(){}};t.None=function(){return L},t.once=e,t.map=n,t.forEach=i,t.filter=r,t.signal=s,t.any=u,t.reduce=c,t.snapshot=a,t.debounce=h,t.stopwatch=p,t.latch=v,t.buffer=l;var E=function(){function t(t){this.event=t}return t.prototype.map=function(e){return new t(n(this.event,e))},t.prototype.forEach=function(e){return new t(i(this.event,e))},t.prototype.filter=function(e){return new t(r(this.event,e))},t.prototype.reduce=function(e,n){return new t(c(this.event,e,n))},t.prototype.latch=function(){return new t(v(this.event))},t.prototype.on=function(t,e,n){return this.event(t,e,n)},t.prototype.once=function(t,n,i){return e(this.event)(t,n,i)},t}();t.chain=d,t.fromNodeEventEmitter=_,t.fromPromise=m,t.toPromise=y}(e.Event||(e.Event={}));var u=-1,c=function(){function t(t,e){void 0===e&&(e=Math.random().toString(18).slice(2,5)),this.customThreshold=t,this.name=e,this._warnCountdown=0}return t.prototype.dispose=function(){this._stacks&&this._stacks.clear()},t.prototype.check=function(t){var e=this,n=u;if("number"==typeof this.customThreshold&&(n=this.customThreshold),0>=n||n>t)return void 0;this._stacks||(this._stacks=new Map);var i=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(i)||0;if(this._stacks.set(i,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=.5*n;var o,s=0;this._stacks.forEach(function(t,e){(!o||t>s)&&(o=e,s=t)}),console.warn("["+this.name+"] potential listener LEAK detected, having "+t+" listeners already. MOST frequent listener ("+s+"):"),console.warn(o)}return function(){var t=e._stacks.get(i)||0;e._stacks.set(i,t-1)}},t}(),f=function(){function t(t){this._disposed=!1,this._options=t,this._leakageMon=u>0?new c(this._options&&this._options.leakWarningThreshold):void 0}return Object.defineProperty(t.prototype,"event",{get:function(){var e=this;return this._event||(this._event=function(n,i,r){e._listeners||(e._listeners=new s.LinkedList);var o=e._listeners.isEmpty();o&&e._options&&e._options.onFirstListenerAdd&&e._options.onFirstListenerAdd(e);var u=e._listeners.push(i?[n,i]:n);o&&e._options&&e._options.onFirstListenerDidAdd&&e._options.onFirstListenerDidAdd(e),e._options&&e._options.onListenerDidAdd&&e._options.onListenerDidAdd(e,n,i);var c;e._leakageMon&&(c=e._leakageMon.check(e._listeners.size));var f;return f={dispose:function(){if(c&&c(),f.dispose=t._noop,!e._disposed&&(u(),e._options&&e._options.onLastListenerRemove)){var n=e._listeners&&!e._listeners.isEmpty();n||e._options.onLastListenerRemove(e)}}},Array.isArray(r)&&r.push(f),f}),this._event},enumerable:!0,configurable:!0}),t.prototype.fire=function(t){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(var e=this._listeners.iterator(),n=e.next();!n.done;n=e.next())this._deliveryQueue.push([n.value,t]);for(;this._deliveryQueue.size>0;){var r=this._deliveryQueue.shift(),o=r[0],u=r[1];try{"function"==typeof o?o.call(void 0,u):o[0].call(o[1],u)}catch(n){i.onUnexpectedError(n)}}}},t.prototype.dispose=function(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0},t._noop=function(){},t}();e.Emitter=f;var a=function(t){function e(e){var n=t.call(this,e)||this;return n._isPaused=0,n._eventQueue=new s.LinkedList,n._mergeFn=e&&e.merge,n}return n(e,t),e.prototype.pause=function(){this._isPaused++},e.prototype.resume=function(){if(0!==this._isPaused&&0===--this._isPaused)if(this._mergeFn){var e=this._eventQueue.toArray();this._eventQueue.clear(),t.prototype.fire.call(this,this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)t.prototype.fire.call(this,this._eventQueue.shift())},e.prototype.fire=function(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):t.prototype.fire.call(this,e))},e}(f);e.PauseableEmitter=a;var h=function(){function t(){var t=this;this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:function(){return t.onFirstListenerAdd()},onLastListenerRemove:function(){return t.onLastListenerRemove()}})}return Object.defineProperty(t.prototype,"event",{get:function(){return this.emitter.event},enumerable:!0,configurable:!0}),t.prototype.add=function(t){var e=this,n={event:t,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);var i=function(){e.hasListeners&&e.unhook(n);var t=e.events.indexOf(n);e.events.splice(t,1)};return o.toDisposable(r.once(i))},t.prototype.onFirstListenerAdd=function(){var t=this;this.hasListeners=!0,this.events.forEach(function(e){return t.hook(e)})},t.prototype.onLastListenerRemove=function(){var t=this;this.hasListeners=!1,this.events.forEach(function(e){return t.unhook(e)})},t.prototype.hook=function(t){var e=this;t.listener=t.event(function(t){return e.emitter.fire(t)})},t.prototype.unhook=function(t){t.listener&&t.listener.dispose(),t.listener=null},t.prototype.dispose=function(){this.emitter.dispose()},t}();e.EventMultiplexer=h;var p=function(){function t(){this.buffers=[]}return t.prototype.wrapEvent=function(t){var e=this;return function(n,i,r){return t(function(t){var r=e.buffers[e.buffers.length-1];r?r.push(function(){return n.call(i,t)}):n.call(i,t)},void 0,r)}},t.prototype.bufferEvents=function(t){var e=[];this.buffers.push(e);var n=t();return this.buffers.pop(),e.forEach(function(t){return t()}),n},t}();e.EventBufferer=p;var v=function(){function t(){var t=this;this.listening=!1,this.inputEvent=e.Event.None,this.inputEventListener=o.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:function(){t.listening=!0,t.inputEventListener=t.inputEvent(t.emitter.fire,t.emitter)},onLastListenerRemove:function(){t.listening=!1,t.inputEventListener.dispose()}}),this.event=this.emitter.event}return Object.defineProperty(t.prototype,"input",{set:function(t){this.inputEvent=t,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=t(this.emitter.fire,this.emitter))},enumerable:!0,configurable:!0}),t.prototype.dispose=function(){this.inputEventListener.dispose(),this.emitter.dispose()},t}();e.Relay=v});
/**! node_modules/monaco-editor/esm/vs/base/common/cancellation.js*/
define("7ed507d",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;var n=e("8451667"),i=Object.freeze(function(e,t){var n=setTimeout(e.bind(t),0);return{dispose:function(){clearTimeout(n)}}});!function(e){function t(t){return t===e.None||t===e.Cancelled?!0:t instanceof o?!0:t&&"object"==typeof t?"boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested:!1}e.isCancellationToken=t,e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})}(t.CancellationToken||(t.CancellationToken={}));var o=function(){function e(){this._isCancelled=!1,this._emitter=null}return e.prototype.cancel=function(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))},Object.defineProperty(e.prototype,"isCancellationRequested",{get:function(){return this._isCancelled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"onCancellationRequested",{get:function(){return this._isCancelled?i:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)},enumerable:!0,configurable:!0}),e.prototype.dispose=function(){this._emitter&&(this._emitter.dispose(),this._emitter=null)},e}(),s=function(){function e(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}return Object.defineProperty(e.prototype,"token",{get:function(){return this._token||(this._token=new o),this._token},enumerable:!0,configurable:!0}),e.prototype.cancel=function(){this._token?this._token instanceof o&&this._token.cancel():this._token=t.CancellationToken.Cancelled},e.prototype.dispose=function(){this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=t.CancellationToken.None},e}();t.CancellationTokenSource=s});
/**! node_modules/monaco-editor/esm/vs/editor/common/standalone/promise-polyfill/polyfill.js*/
define("4a24931",function(e,n,t,o){!function(e,r){"object"==typeof n&&"undefined"!=typeof t?r():"function"==typeof o&&o.amd?o(r):r()}(this,function(){"use strict";function e(e){var n=this.constructor;return this.then(function(t){return n.resolve(e()).then(function(){return t})},function(t){return n.resolve(e()).then(function(){return n.reject(t)})})}function n(){}function t(e,n){return function(){e.apply(n,arguments)}}function o(e){if(!(this instanceof o))throw new TypeError("Promises must be constructed via new");if("function"!=typeof e)throw new TypeError("not a function");this._state=0,this._handled=!1,this._value=void 0,this._deferreds=[],a(e,this)}function r(e,n){for(;3===e._state;)e=e._value;return 0===e._state?void e._deferreds.push(n):(e._handled=!0,void o._immediateFn(function(){var t=1===e._state?n.onFulfilled:n.onRejected;if(null===t)return void(1===e._state?i:f)(n.promise,e._value);var o;try{o=t(e._value)}catch(r){return void f(n.promise,r)}i(n.promise,o)}))}function i(e,n){try{if(n===e)throw new TypeError("A promise cannot be resolved with itself.");if(n&&("object"==typeof n||"function"==typeof n)){var r=n.then;if(n instanceof o)return e._state=3,e._value=n,void u(e);if("function"==typeof r)return void a(t(r,n),e)}e._state=1,e._value=n,u(e)}catch(i){f(e,i)}}function f(e,n){e._state=2,e._value=n,u(e)}function u(e){2===e._state&&0===e._deferreds.length&&o._immediateFn(function(){e._handled||o._unhandledRejectionFn(e._value)});for(var n=0,t=e._deferreds.length;t>n;n++)r(e,e._deferreds[n]);e._deferreds=null}function c(e,n,t){this.onFulfilled="function"==typeof e?e:null,this.onRejected="function"==typeof n?n:null,this.promise=t}function a(e,n){var t=!1;try{e(function(e){t||(t=!0,i(n,e))},function(e){t||(t=!0,f(n,e))})}catch(o){if(t)return;t=!0,f(n,o)}}var l=setTimeout;o.prototype["catch"]=function(e){return this.then(null,e)},o.prototype.then=function(e,t){var o=new this.constructor(n);return r(this,new c(e,t,o)),o},o.prototype["finally"]=e,o.all=function(e){return new o(function(n,t){function o(e,f){try{if(f&&("object"==typeof f||"function"==typeof f)){var u=f.then;if("function"==typeof u)return void u.call(f,function(n){o(e,n)},t)}r[e]=f,0===--i&&n(r)}catch(c){t(c)}}if(!e||"undefined"==typeof e.length)throw new TypeError("Promise.all accepts an array");var r=Array.prototype.slice.call(e);if(0===r.length)return n([]);for(var i=r.length,f=0;f<r.length;f++)o(f,r[f])})},o.resolve=function(e){return e&&"object"==typeof e&&e.constructor===o?e:new o(function(n){n(e)})},o.reject=function(e){return new o(function(n,t){t(e)})},o.race=function(e){return new o(function(n,t){for(var o=0,r=e.length;r>o;o++)e[o].then(n,t)})},o._immediateFn="function"==typeof setImmediate&&function(e){setImmediate(e)}||function(e){l(e,0)},o._unhandledRejectionFn=function(e){"undefined"!=typeof console&&console&&console.warn("Possible Unhandled Promise Rejection:",e)};var s=function(){if("undefined"!=typeof self)return self;if("undefined"!=typeof window)return window;if("undefined"!=typeof global)return global;throw new Error("unable to locate global object")}();"Promise"in s?s.Promise.prototype["finally"]||(s.Promise.prototype["finally"]=e):s.Promise=o})});
/**! node_modules/tslib/tslib.js*/
define("11ed2ab",function(t,e,n,r){var o,a,i,u,c,f,l,s,y,p,_,b,h,d,v,m,w,g,O,j,S,P,x;!function(t){function e(t,e){return t!==o&&("function"==typeof Object.create?Object.defineProperty(t,"__esModule",{value:!0}):t.__esModule=!0),function(n,r){return t[n]=e?e(n,r):r}}var o="object"==typeof global?global:"object"==typeof self?self:"object"==typeof this?this:{};"function"==typeof r&&r.amd?r("tslib",["exports"],function(n){t(e(o,e(n)))}):t("object"==typeof n&&"object"==typeof n.exports?e(o,e(n.exports)):e(o))}(function(t){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])};o=function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)},a=Object.assign||function(t){for(var e,n=1,r=arguments.length;r>n;n++){e=arguments[n];for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&(t[o]=e[o])}return t},i=function(t,e){var n={};for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e.indexOf(r)<0&&(n[r]=t[r]);if(null!=t&&"function"==typeof Object.getOwnPropertySymbols)for(var o=0,r=Object.getOwnPropertySymbols(t);o<r.length;o++)e.indexOf(r[o])<0&&Object.prototype.propertyIsEnumerable.call(t,r[o])&&(n[r[o]]=t[r[o]]);return n},u=function(t,e,n,r){var o,a=arguments.length,i=3>a?e:null===r?r=Object.getOwnPropertyDescriptor(e,n):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(t,e,n,r);else for(var u=t.length-1;u>=0;u--)(o=t[u])&&(i=(3>a?o(i):a>3?o(e,n,i):o(e,n))||i);return a>3&&i&&Object.defineProperty(e,n,i),i},c=function(t,e){return function(n,r){e(n,r,t)}},f=function(t,e){return"object"==typeof Reflect&&"function"==typeof Reflect.metadata?Reflect.metadata(t,e):void 0},l=function(t,e,n,r){function o(t){return t instanceof n?t:new n(function(e){e(t)})}return new(n||(n=Promise))(function(n,a){function i(t){try{c(r.next(t))}catch(e){a(e)}}function u(t){try{c(r["throw"](t))}catch(e){a(e)}}function c(t){t.done?n(t.value):o(t.value).then(i,u)}c((r=r.apply(t,e||[])).next())})},s=function(t,e){function n(t){return function(e){return r([t,e])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;c;)try{if(o=1,a&&(i=2&n[0]?a["return"]:n[0]?a["throw"]||((i=a["return"])&&i.call(a),0):a.next)&&!(i=i.call(a,n[1])).done)return i;switch(a=0,i&&(n=[2&n[0],i.value]),n[0]){case 0:case 1:i=n;break;case 4:return c.label++,{value:n[1],done:!1};case 5:c.label++,a=n[1],n=[0];continue;case 7:n=c.ops.pop(),c.trys.pop();continue;default:if(i=c.trys,!(i=i.length>0&&i[i.length-1])&&(6===n[0]||2===n[0])){c=0;continue}if(3===n[0]&&(!i||n[1]>i[0]&&n[1]<i[3])){c.label=n[1];break}if(6===n[0]&&c.label<i[1]){c.label=i[1],i=n;break}if(i&&c.label<i[2]){c.label=i[2],c.ops.push(n);break}i[2]&&c.ops.pop(),c.trys.pop();continue}n=e.call(t,c)}catch(r){n=[6,r],a=0}finally{o=i=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,a,i,u,c={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return u={next:n(0),"throw":n(1),"return":n(2)},"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u},x=function(t,e,n,r){void 0===r&&(r=n),t[r]=e[n]},y=function(t,e){for(var n in t)"default"===n||e.hasOwnProperty(n)||(e[n]=t[n])},p=function(t){var e="function"==typeof Symbol&&Symbol.iterator,n=e&&t[e],r=0;if(n)return n.call(t);if(t&&"number"==typeof t.length)return{next:function(){return t&&r>=t.length&&(t=void 0),{value:t&&t[r++],done:!t}}};throw new TypeError(e?"Object is not iterable.":"Symbol.iterator is not defined.")},_=function(t,e){var n="function"==typeof Symbol&&t[Symbol.iterator];if(!n)return t;var r,o,a=n.call(t),i=[];try{for(;(void 0===e||e-->0)&&!(r=a.next()).done;)i.push(r.value)}catch(u){o={error:u}}finally{try{r&&!r.done&&(n=a["return"])&&n.call(a)}finally{if(o)throw o.error}}return i},b=function(){for(var t=[],e=0;e<arguments.length;e++)t=t.concat(_(arguments[e]));return t},h=function(){for(var t=0,e=0,n=arguments.length;n>e;e++)t+=arguments[e].length;for(var r=Array(t),o=0,e=0;n>e;e++)for(var a=arguments[e],i=0,u=a.length;u>i;i++,o++)r[o]=a[i];return r},d=function(t){return this instanceof d?(this.v=t,this):new d(t)},v=function(t,e,n){function r(t){l[t]&&(f[t]=function(e){return new Promise(function(n,r){s.push([t,e,n,r])>1||o(t,e)})})}function o(t,e){try{a(l[t](e))}catch(n){c(s[0][3],n)}}function a(t){t.value instanceof d?Promise.resolve(t.value.v).then(i,u):c(s[0][2],t)}function i(t){o("next",t)}function u(t){o("throw",t)}function c(t,e){t(e),s.shift(),s.length&&o(s[0][0],s[0][1])}if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var f,l=n.apply(t,e||[]),s=[];return f={},r("next"),r("throw"),r("return"),f[Symbol.asyncIterator]=function(){return this},f},m=function(t){function e(e,o){n[e]=t[e]?function(n){return(r=!r)?{value:d(t[e](n)),done:"return"===e}:o?o(n):n}:o}var n,r;return n={},e("next"),e("throw",function(t){throw t}),e("return"),n[Symbol.iterator]=function(){return this},n},w=function(t){function e(e){r[e]=t[e]&&function(r){return new Promise(function(o,a){r=t[e](r),n(o,a,r.done,r.value)})}}function n(t,e,n,r){Promise.resolve(r).then(function(e){t({value:e,done:n})},e)}if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var r,o=t[Symbol.asyncIterator];return o?o.call(t):(t="function"==typeof p?p(t):t[Symbol.iterator](),r={},e("next"),e("throw"),e("return"),r[Symbol.asyncIterator]=function(){return this},r)},g=function(t,e){return Object.defineProperty?Object.defineProperty(t,"raw",{value:e}):t.raw=e,t},O=function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var n in t)Object.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e["default"]=t,e},j=function(t){return t&&t.__esModule?t:{"default":t}},S=function(t,e){if(!e.has(t))throw new TypeError("attempted to get private field on non-instance");return e.get(t)},P=function(t,e,n){if(!e.has(t))throw new TypeError("attempted to set private field on non-instance");return e.set(t,n),n},t("__extends",o),t("__assign",a),t("__rest",i),t("__decorate",u),t("__param",c),t("__metadata",f),t("__awaiter",l),t("__generator",s),t("__exportStar",y),t("__createBinding",x),t("__values",p),t("__read",_),t("__spread",b),t("__spreadArrays",h),t("__await",d),t("__asyncGenerator",v),t("__asyncDelegator",m),t("__asyncValues",w),t("__makeTemplateObject",g),t("__importStar",O),t("__importDefault",j),t("__classPrivateFieldGet",S),t("__classPrivateFieldSet",P)})});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/uint.js*/
define("4186ef1",function(t,n){"use strict";function i(t){return 0>t?0:t>255?255:0|t}function r(t){return 0>t?0:t>4294967295?4294967295:0|t}function o(t){for(var n=t.length,i=new Uint32Array(n),o=0;n>o;o++)i[o]=r(t[o]);return i}Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32Array=n.toUint32=n.toUint8=n.Uint8Matrix=void 0;var e=function(){function t(t,n,i){for(var r=new Uint8Array(t*n),o=0,e=t*n;e>o;o++)r[o]=i;this._data=r,this.rows=t,this.cols=n}return t.prototype.get=function(t,n){return this._data[t*this.cols+n]},t.prototype.set=function(t,n,i){this._data[t*this.cols+n]=i},t}();n.Uint8Matrix=e,n.toUint8=i,n.toUint32=r,n.toUint32Array=o});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/characterClassifier.js*/
define("206e614",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;var a=t("4186ef1"),i=function(){function t(e){var i=a.toUint8(e);this._defaultValue=i,this._asciiMap=t._createAsciiMap(i),this._map=new Map}return t._createAsciiMap=function(t){for(var e=new Uint8Array(256),a=0;256>a;a++)e[a]=t;return e},t.prototype.set=function(t,e){var i=a.toUint8(e);t>=0&&256>t?this._asciiMap[t]=i:this._map.set(t,i)},t.prototype.get=function(t){return t>=0&&256>t?this._asciiMap[t]:this._map.get(t)||this._defaultValue},t}();e.CharacterClassifier=i;var r=function(){function t(){this._actual=new i(0)}return t.prototype.add=function(t){this._actual.set(t,1)},t.prototype.has=function(t){return 1===this._actual.get(t)},t}();e.CharacterSet=r});
/**! node_modules/monaco-editor/esm/vs/editor/common/viewModel/prefixSumComputer.js*/
define("cf86ba2",function(t,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputerWithCache=e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;var i=t("4186ef1"),u=function(){function t(t,e){this.index=t,this.remainder=e}return t}();e.PrefixSumIndexOfResult=u;var a=function(){function t(t){this.values=t,this.prefixSum=new Uint32Array(t.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}return t.prototype.getCount=function(){return this.values.length},t.prototype.insertValues=function(t,e){t=i.toUint32(t);var u=this.values,a=this.prefixSum,r=e.length;return 0===r?!1:(this.values=new Uint32Array(u.length+r),this.values.set(u.subarray(0,t),0),this.values.set(u.subarray(t),t+r),this.values.set(e,t),t-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=t-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},t.prototype.changeValue=function(t,e){return t=i.toUint32(t),e=i.toUint32(e),this.values[t]===e?!1:(this.values[t]=e,t-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=t-1),!0)},t.prototype.removeValues=function(t,e){t=i.toUint32(t),e=i.toUint32(e);var u=this.values,a=this.prefixSum;if(t>=u.length)return!1;var r=u.length-t;return e>=r&&(e=r),0===e?!1:(this.values=new Uint32Array(u.length-e),this.values.set(u.subarray(0,t),0),this.values.set(u.subarray(t+e),t),this.prefixSum=new Uint32Array(this.values.length),t-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=t-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(a.subarray(0,this.prefixSumValidIndex[0]+1)),!0)},t.prototype.getTotalValue=function(){return 0===this.values.length?0:this._getAccumulatedValue(this.values.length-1)},t.prototype.getAccumulatedValue=function(t){return 0>t?0:(t=i.toUint32(t),this._getAccumulatedValue(t))},t.prototype._getAccumulatedValue=function(t){if(t<=this.prefixSumValidIndex[0])return this.prefixSum[t];var e=this.prefixSumValidIndex[0]+1;0===e&&(this.prefixSum[0]=this.values[0],e++),t>=this.values.length&&(t=this.values.length-1);for(var i=e;t>=i;i++)this.prefixSum[i]=this.prefixSum[i-1]+this.values[i];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],t),this.prefixSum[t]},t.prototype.getIndexOf=function(t){t=Math.floor(t),this.getTotalValue();for(var e=0,i=this.values.length-1,a=0,r=0,s=0;i>=e;)if(a=e+(i-e)/2|0,r=this.prefixSum[a],s=r-this.values[a],s>t)i=a-1;else{if(!(t>=r))break;e=a+1}return new u(a,t-s)},t}();e.PrefixSumComputer=a;var r=function(){function t(t){this._cacheAccumulatedValueStart=0,this._cache=null,this._actual=new a(t),this._bustCache()}return t.prototype._bustCache=function(){this._cacheAccumulatedValueStart=0,this._cache=null},t.prototype.insertValues=function(t,e){this._actual.insertValues(t,e)&&this._bustCache()},t.prototype.changeValue=function(t,e){this._actual.changeValue(t,e)&&this._bustCache()},t.prototype.removeValues=function(t,e){this._actual.removeValues(t,e)&&this._bustCache()},t.prototype.getTotalValue=function(){return this._actual.getTotalValue()},t.prototype.getAccumulatedValue=function(t){return this._actual.getAccumulatedValue(t)},t.prototype.getIndexOf=function(t){if(t=Math.floor(t),null!==this._cache){var e=t-this._cacheAccumulatedValueStart;if(e>=0&&e<this._cache.length)return this._cache[e]}return this._actual.getIndexOf(t)},t.prototype.warmUpCache=function(t,e){for(var i=[],u=t;e>=u;u++)i[u-t]=this.getIndexOf(u);this._cache=i,this._cacheAccumulatedValueStart=t},t}();e.PrefixSumComputerWithCache=r});
/**! node_modules/monaco-editor/esm/vs/base/common/strings.js*/
define("572f899",function(r,e){"use strict";function t(r){return r&&"string"==typeof r?0===r.trim().length:!0}function n(r,e,t){void 0===t&&(t="0");for(var n=""+r,u=[n],i=n.length;e>i;i++)u.push(t);return u.reverse().join("")}function u(r){for(var e=[],t=1;t<arguments.length;t++)e[t-1]=arguments[t];return 0===e.length?r:r.replace(N,function(r,t){var n=parseInt(t,10);return isNaN(n)||0>n||n>=e.length?r:e[n]})}function i(r){return r.replace(/[<>&]/g,function(r){switch(r){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return r}})}function a(r){return r.replace(/[\-\\\{\}\*\+\?\|\^\$\.\[\]\(\)\#]/g,"\\$&")}function o(r,e){void 0===e&&(e=" ");var t=s(r,e);return c(t,e)}function s(r,e){if(!r||!e)return r;var t=e.length;if(0===t||0===r.length)return r;for(var n=0;r.indexOf(e,n)===n;)n+=t;return r.substring(n)}function c(r,e){if(!r||!e)return r;var t=e.length,n=r.length;if(0===t||0===n)return r;for(var u=n,i=-1;;){if(i=r.lastIndexOf(e,u-1),-1===i||i+t!==u)break;if(0===i)return"";u=i}return r.substring(0,u)}function f(r){return r.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function g(r,e){if(r.length<e.length)return!1;if(r===e)return!0;for(var t=0;t<e.length;t++)if(r[t]!==e[t])return!1;return!0}function h(r,e){var t=r.length-e.length;return t>0?r.indexOf(e,t)===t:0===t?r===e:!1}function l(r,e,t){if(void 0===t&&(t={}),!r)throw new Error("Cannot create regex from empty string");e||(r=a(r)),t.wholeWord&&(/\B/.test(r.charAt(0))||(r="\\b"+r),/\B/.test(r.charAt(r.length-1))||(r+="\\b"));var n="";return t.global&&(n+="g"),t.matchCase||(n+="i"),t.multiline&&(n+="m"),t.unicode&&(n+="u"),new RegExp(r,n)}function D(r){if("^"===r.source||"^$"===r.source||"$"===r.source||"^\\s*$"===r.source)return!1;var e=r.exec("");return!(!e||0!==r.lastIndex)}function F(r){return(r.global?"g":"")+(r.ignoreCase?"i":"")+(r.multiline?"m":"")+(r.unicode?"u":"")}function d(r){for(var e=0,t=r.length;t>e;e++){var n=r.charCodeAt(e);if(32!==n&&9!==n)return e}return-1}function p(r,e,t){void 0===e&&(e=0),void 0===t&&(t=r.length);for(var n=e;t>n;n++){var u=r.charCodeAt(n);if(32!==u&&9!==u)return r.substring(e,n)}return r.substring(e,t)}function C(r,e){void 0===e&&(e=r.length-1);for(var t=e;t>=0;t--){var n=r.charCodeAt(t);if(32!==n&&9!==n)return t}return-1}function E(r,e){return e>r?-1:r>e?1:0}function v(r){return r>=97&&122>=r}function m(r){return r>=65&&90>=r}function A(r){return v(r)||m(r)}function B(r,e){var t=r?r.length:0,n=e?e.length:0;return t!==n?!1:x(r,e)}function x(r,e,t){if(void 0===t&&(t=r.length),"string"!=typeof r||"string"!=typeof e)return!1;for(var n=0;t>n;n++){var u=r.charCodeAt(n),i=e.charCodeAt(n);if(u!==i)if(A(u)&&A(i)){var a=Math.abs(u-i);if(0!==a&&32!==a)return!1}else if(String.fromCharCode(u).toLowerCase()!==String.fromCharCode(i).toLowerCase())return!1}return!0}function L(r,e){var t=e.length;return e.length>r.length?!1:x(r,e,t)}function W(r,e){var t,n=Math.min(r.length,e.length);for(t=0;n>t;t++)if(r.charCodeAt(t)!==e.charCodeAt(t))return t;return n}function I(r,e){var t,n=Math.min(r.length,e.length),u=r.length-1,i=e.length-1;for(t=0;n>t;t++)if(r.charCodeAt(u-t)!==e.charCodeAt(i-t))return t;return n}function R(r){return r>=55296&&56319>=r}function S(r){return r>=56320&&57343>=r}function b(r){return _.test(r)}function w(r){return P.test(r)}function O(r){return j.test(r)}function T(r){for(var e=0,t=r.length;t>e;e++)if(y(r.charCodeAt(e)))return!0;return!1}function y(r){return r=+r,r>=11904&&55215>=r||r>=63744&&64255>=r||r>=65281&&65374>=r}function M(r){return!!(r&&r.length>0&&65279===r.charCodeAt(0))}function $(r){return btoa(encodeURIComponent(r))}function U(r,e){for(var t="",n=0;e>n;n++)t+=r;return t}Object.defineProperty(e,"__esModule",{value:!0}),e.repeat=e.safeBtoa=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.regExpFlags=e.regExpLeadsToEndlessLoop=e.createRegExp=e.endsWith=e.startsWith=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.escapeRegExpCharacters=e.escape=e.format=e.pad=e.isFalsyOrWhitespace=e.empty=void 0,e.empty="",e.isFalsyOrWhitespace=t,e.pad=n;var N=/{(\d+)}/g;e.format=u,e.escape=i,e.escapeRegExpCharacters=a,e.trim=o,e.ltrim=s,e.rtrim=c,e.convertSimple2RegExpPattern=f,e.startsWith=g,e.endsWith=h,e.createRegExp=l,e.regExpLeadsToEndlessLoop=D,e.regExpFlags=F,e.firstNonWhitespaceIndex=d,e.getLeadingWhitespace=p,e.lastNonWhitespaceIndex=C,e.compare=E,e.isLowerAsciiLetter=v,e.isUpperAsciiLetter=m,e.equalsIgnoreCase=B,e.startsWithIgnoreCase=L,e.commonPrefixLength=W,e.commonSuffixLength=I,e.isHighSurrogate=R,e.isLowSurrogate=S;var _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;e.containsRTL=b;var P=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEF8]|\uD83E[\uDD00-\uDDE6])/;e.containsEmoji=w;var j=/^[\t\n\r\x20-\x7E]*$/;e.isBasicASCII=O,e.containsFullWidthCharacter=T,e.isFullWidthCharacter=y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279),e.startsWithUTF8BOM=M,e.safeBtoa=$,e.repeat=U});
/**! node_modules/tslib/tslib.js*/
define("11ed2ab",function(t,e,n,r){var o,a,i,u,c,f,l,s,y,p,_,b,h,d,v,m,w,g,O,j,S,P,x;!function(t){function e(t,e){return t!==o&&("function"==typeof Object.create?Object.defineProperty(t,"__esModule",{value:!0}):t.__esModule=!0),function(n,r){return t[n]=e?e(n,r):r}}var o="object"==typeof global?global:"object"==typeof self?self:"object"==typeof this?this:{};"function"==typeof r&&r.amd?r("tslib",["exports"],function(n){t(e(o,e(n)))}):t("object"==typeof n&&"object"==typeof n.exports?e(o,e(n.exports)):e(o))}(function(t){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])};o=function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)},a=Object.assign||function(t){for(var e,n=1,r=arguments.length;r>n;n++){e=arguments[n];for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&(t[o]=e[o])}return t},i=function(t,e){var n={};for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&e.indexOf(r)<0&&(n[r]=t[r]);if(null!=t&&"function"==typeof Object.getOwnPropertySymbols)for(var o=0,r=Object.getOwnPropertySymbols(t);o<r.length;o++)e.indexOf(r[o])<0&&Object.prototype.propertyIsEnumerable.call(t,r[o])&&(n[r[o]]=t[r[o]]);return n},u=function(t,e,n,r){var o,a=arguments.length,i=3>a?e:null===r?r=Object.getOwnPropertyDescriptor(e,n):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)i=Reflect.decorate(t,e,n,r);else for(var u=t.length-1;u>=0;u--)(o=t[u])&&(i=(3>a?o(i):a>3?o(e,n,i):o(e,n))||i);return a>3&&i&&Object.defineProperty(e,n,i),i},c=function(t,e){return function(n,r){e(n,r,t)}},f=function(t,e){return"object"==typeof Reflect&&"function"==typeof Reflect.metadata?Reflect.metadata(t,e):void 0},l=function(t,e,n,r){function o(t){return t instanceof n?t:new n(function(e){e(t)})}return new(n||(n=Promise))(function(n,a){function i(t){try{c(r.next(t))}catch(e){a(e)}}function u(t){try{c(r["throw"](t))}catch(e){a(e)}}function c(t){t.done?n(t.value):o(t.value).then(i,u)}c((r=r.apply(t,e||[])).next())})},s=function(t,e){function n(t){return function(e){return r([t,e])}}function r(n){if(o)throw new TypeError("Generator is already executing.");for(;c;)try{if(o=1,a&&(i=2&n[0]?a["return"]:n[0]?a["throw"]||((i=a["return"])&&i.call(a),0):a.next)&&!(i=i.call(a,n[1])).done)return i;switch(a=0,i&&(n=[2&n[0],i.value]),n[0]){case 0:case 1:i=n;break;case 4:return c.label++,{value:n[1],done:!1};case 5:c.label++,a=n[1],n=[0];continue;case 7:n=c.ops.pop(),c.trys.pop();continue;default:if(i=c.trys,!(i=i.length>0&&i[i.length-1])&&(6===n[0]||2===n[0])){c=0;continue}if(3===n[0]&&(!i||n[1]>i[0]&&n[1]<i[3])){c.label=n[1];break}if(6===n[0]&&c.label<i[1]){c.label=i[1],i=n;break}if(i&&c.label<i[2]){c.label=i[2],c.ops.push(n);break}i[2]&&c.ops.pop(),c.trys.pop();continue}n=e.call(t,c)}catch(r){n=[6,r],a=0}finally{o=i=0}if(5&n[0])throw n[1];return{value:n[0]?n[1]:void 0,done:!0}}var o,a,i,u,c={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return u={next:n(0),"throw":n(1),"return":n(2)},"function"==typeof Symbol&&(u[Symbol.iterator]=function(){return this}),u},x=function(t,e,n,r){void 0===r&&(r=n),t[r]=e[n]},y=function(t,e){for(var n in t)"default"===n||e.hasOwnProperty(n)||(e[n]=t[n])},p=function(t){var e="function"==typeof Symbol&&Symbol.iterator,n=e&&t[e],r=0;if(n)return n.call(t);if(t&&"number"==typeof t.length)return{next:function(){return t&&r>=t.length&&(t=void 0),{value:t&&t[r++],done:!t}}};throw new TypeError(e?"Object is not iterable.":"Symbol.iterator is not defined.")},_=function(t,e){var n="function"==typeof Symbol&&t[Symbol.iterator];if(!n)return t;var r,o,a=n.call(t),i=[];try{for(;(void 0===e||e-->0)&&!(r=a.next()).done;)i.push(r.value)}catch(u){o={error:u}}finally{try{r&&!r.done&&(n=a["return"])&&n.call(a)}finally{if(o)throw o.error}}return i},b=function(){for(var t=[],e=0;e<arguments.length;e++)t=t.concat(_(arguments[e]));return t},h=function(){for(var t=0,e=0,n=arguments.length;n>e;e++)t+=arguments[e].length;for(var r=Array(t),o=0,e=0;n>e;e++)for(var a=arguments[e],i=0,u=a.length;u>i;i++,o++)r[o]=a[i];return r},d=function(t){return this instanceof d?(this.v=t,this):new d(t)},v=function(t,e,n){function r(t){l[t]&&(f[t]=function(e){return new Promise(function(n,r){s.push([t,e,n,r])>1||o(t,e)})})}function o(t,e){try{a(l[t](e))}catch(n){c(s[0][3],n)}}function a(t){t.value instanceof d?Promise.resolve(t.value.v).then(i,u):c(s[0][2],t)}function i(t){o("next",t)}function u(t){o("throw",t)}function c(t,e){t(e),s.shift(),s.length&&o(s[0][0],s[0][1])}if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var f,l=n.apply(t,e||[]),s=[];return f={},r("next"),r("throw"),r("return"),f[Symbol.asyncIterator]=function(){return this},f},m=function(t){function e(e,o){n[e]=t[e]?function(n){return(r=!r)?{value:d(t[e](n)),done:"return"===e}:o?o(n):n}:o}var n,r;return n={},e("next"),e("throw",function(t){throw t}),e("return"),n[Symbol.iterator]=function(){return this},n},w=function(t){function e(e){r[e]=t[e]&&function(r){return new Promise(function(o,a){r=t[e](r),n(o,a,r.done,r.value)})}}function n(t,e,n,r){Promise.resolve(r).then(function(e){t({value:e,done:n})},e)}if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var r,o=t[Symbol.asyncIterator];return o?o.call(t):(t="function"==typeof p?p(t):t[Symbol.iterator](),r={},e("next"),e("throw"),e("return"),r[Symbol.asyncIterator]=function(){return this},r)},g=function(t,e){return Object.defineProperty?Object.defineProperty(t,"raw",{value:e}):t.raw=e,t},O=function(t){if(t&&t.__esModule)return t;var e={};if(null!=t)for(var n in t)Object.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e["default"]=t,e},j=function(t){return t&&t.__esModule?t:{"default":t}},S=function(t,e){if(!e.has(t))throw new TypeError("attempted to get private field on non-instance");return e.get(t)},P=function(t,e,n){if(!e.has(t))throw new TypeError("attempted to set private field on non-instance");return e.set(t,n),n},t("__extends",o),t("__assign",a),t("__rest",i),t("__decorate",u),t("__param",c),t("__metadata",f),t("__awaiter",l),t("__generator",s),t("__exportStar",y),t("__createBinding",x),t("__values",p),t("__read",_),t("__spread",b),t("__spreadArrays",h),t("__await",d),t("__asyncGenerator",v),t("__asyncDelegator",m),t("__asyncValues",w),t("__makeTemplateObject",g),t("__importStar",O),t("__importDefault",j),t("__classPrivateFieldGet",S),t("__classPrivateFieldSet",P)})});
/**! node_modules/monaco-editor/esm/vs/base/common/diff/diffChange.js*/
define("a895ddf",function(i,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;var e=function(){function i(i,t,e,n){this.originalStart=i,this.originalLength=t,this.modifiedStart=e,this.modifiedLength=n}return i.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},i.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},i}();t.DiffChange=e});
/**! node_modules/monaco-editor/esm/vs/base/common/types.js*/
define("01fef85",function(n,t){"use strict";function e(n){return Array.isArray?Array.isArray(n):n&&typeof n.length===b.number&&n.constructor===Array?!0:!1}function r(n){return typeof n===b.string||n instanceof String?!0:!1}function i(n){return!(typeof n!==b.object||null===n||Array.isArray(n)||n instanceof RegExp||n instanceof Date)}function o(n){return(typeof n===b.number||n instanceof Number)&&!isNaN(n)?!0:!1}function u(n){return n===!0||n===!1}function f(n){return typeof n===b.undefined}function s(n){return f(n)||null===n}function a(n){if(!i(n))return!1;for(var t in n)if(m.call(n,t))return!1;return!0}function c(n){return typeof n===b.function}function l(n,t){for(var e=Math.min(n.length,t.length),r=0;e>r;r++)d(n[r],t[r])}function d(n,t){if(r(t)){if(typeof n!==t)throw new Error("argument does not match constraint: typeof "+t)}else if(c(t)){try{if(n instanceof t)return}catch(e){}if(!s(n)&&n.constructor===t)return;if(1===t.length&&t.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function y(n){for(var t=[],e=Object.getPrototypeOf(n);Object.prototype!==e;)t=t.concat(Object.getOwnPropertyNames(e)),e=Object.getPrototypeOf(e);return t}function p(n){return null===n?void 0:n}function g(n){return"undefined"==typeof n?null:n}Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.isFunction=t.isEmptyObject=t.isUndefinedOrNull=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isString=t.isArray=void 0;var b={number:"number",string:"string",undefined:"undefined",object:"object","function":"function"};t.isArray=e,t.isString=r,t.isObject=i,t.isNumber=o,t.isBoolean=u,t.isUndefined=f,t.isUndefinedOrNull=s;var m=Object.prototype.hasOwnProperty;t.isEmptyObject=a,t.isFunction=c,t.validateConstraints=l,t.validateConstraint=d,t.getAllPropertyNames=y,t.withNullAsUndefined=p,t.withUndefinedAsNull=g});
/**! node_modules/monaco-editor/esm/vs/editor/common/standalone/standaloneBase.js*/
define("4dc9450",function(e,o){"use strict";function n(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.CancellationTokenSource,Emitter:i.Emitter,KeyCode:M.KeyCode,KeyMod:S,Position:d.Position,Range:l.Range,Selection:u.Selection,SelectionDirection:M.SelectionDirection,MarkerSeverity:M.MarkerSeverity,MarkerTag:M.MarkerTag,Uri:c.URI,Token:f.Token}}Object.defineProperty(o,"__esModule",{value:!0}),o.createMonacoBaseAPI=o.KeyMod=void 0;var r=e("11ed2ab");e("4a24931");var t=e("7ed507d"),i=e("8451667"),a=e("651ae9b"),c=e("50db2b4"),d=e("5ddf902"),l=e("4661130"),u=e("3b7eb07"),f=e("57d67ff"),M=r.__importStar(e("2e266ae")),S=function(){function e(){}return e.chord=function(e,o){return a.KeyChord(e,o)},e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256,e}();o.KeyMod=S,o.createMonacoBaseAPI=n});
/**! node_modules/monaco-editor/esm/vs/editor/common/modes/supports/inplaceReplaceSupport.js*/
define("670df80",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;var a=function(){function e(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return e.prototype.navigateValueSet=function(e,t,a,l,n){if(e&&t){var r=this.doNavigateValueSet(t,n);if(r)return{range:e,value:r}}if(a&&l){var r=this.doNavigateValueSet(l,n);if(r)return{range:a,value:r}}return null},e.prototype.doNavigateValueSet=function(e,t){var a=this.numberReplace(e,t);return null!==a?a:this.textReplace(e,t)},e.prototype.numberReplace=function(e,t){var a=Math.pow(10,e.length-(e.lastIndexOf(".")+1)),l=Number(e),n=parseFloat(e);return isNaN(l)||isNaN(n)||l!==n?null:0!==l||t?(l=Math.floor(l*a),l+=t?a:-a,String(l/a)):null},e.prototype.textReplace=function(e,t){return this.valueSetsReplace(this._defaultValueSet,e,t)},e.prototype.valueSetsReplace=function(e,t,a){for(var l=null,n=0,r=e.length;null===l&&r>n;n++)l=this.valueSetReplace(e[n],t,a);return l},e.prototype.valueSetReplace=function(e,t,a){var l=e.indexOf(t);return l>=0?(l+=a?1:-1,0>l?l=e.length-1:l%=e.length,e[l]):null},e.INSTANCE=new e,e}();t.BasicInplaceReplace=a});
/**! node_modules/monaco-editor/esm/vs/editor/common/modes/linkComputer.js*/
define("fabf684",function(e,t){"use strict";function n(){return null===c&&(c=new u([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),c}function r(){if(null===s){s=new i.CharacterClassifier(0);for(var e=" 	<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…",t=0;t<e.length;t++)s.set(e.charCodeAt(t),1);for(var n=".,;",t=0;t<n.length;t++)s.set(n.charCodeAt(t),2)}return s}function a(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?f.computeLinks(e):[]}Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=void 0;var i=e("206e614"),o=e("4186ef1"),u=function(){function e(e){for(var t=0,n=0,r=0,a=e.length;a>r;r++){var i=e[r],u=i[0],c=i[1],s=i[2];c>t&&(t=c),u>n&&(n=u),s>n&&(n=s)}t++,n++;for(var f=new o.Uint8Matrix(n,t,0),r=0,a=e.length;a>r;r++){var h=e[r],u=h[0],c=h[1],s=h[2];f.set(u,c,s)}this._states=f,this._maxCharCode=t}return e.prototype.nextState=function(e,t){return 0>t||t>=this._maxCharCode?0:this._states.get(e,t)},e}();t.StateMachine=u;var c=null,s=null,f=function(){function e(){}return e._createLink=function(e,t,n,r,a){var i=a-1;do{var o=t.charCodeAt(i),u=e.get(o);if(2!==u)break;i--}while(i>r);if(r>0){var c=t.charCodeAt(r-1),s=t.charCodeAt(i);(40===c&&41===s||91===c&&93===s||123===c&&125===s)&&i--}return{range:{startLineNumber:n,startColumn:r+1,endLineNumber:n,endColumn:i+2},url:t.substring(r,i+1)}},e.computeLinks=function(t,a){void 0===a&&(a=n());for(var i=r(),o=[],u=1,c=t.getLineCount();c>=u;u++){for(var s=t.getLineContent(u),f=s.length,h=0,l=0,v=0,C=1,d=!1,k=!1,b=!1;f>h;){var g=!1,L=s.charCodeAt(h);if(13===C){var m=void 0;switch(L){case 40:d=!0,m=0;break;case 41:m=d?0:1;break;case 91:k=!0,m=0;break;case 93:m=k?0:1;break;case 123:b=!0,m=0;break;case 125:m=b?0:1;break;case 39:m=34===v||96===v?0:1;break;case 34:m=39===v||96===v?0:1;break;case 96:m=39===v||34===v?0:1;break;default:m=i.get(L)}1===m&&(o.push(e._createLink(i,s,u,l,h)),g=!0)}else if(12===C){var m=void 0;91===L?(k=!0,m=0):m=i.get(L),1===m?g=!0:C=13}else C=a.nextState(C,L),0===C&&(g=!0);g&&(C=1,d=!1,k=!1,b=!1,l=h+1,v=L),h++}13===C&&o.push(e._createLink(i,s,u,l,f))}return o},e}();t.LinkComputer=f,t.computeLinks=a});
/**! node_modules/monaco-editor/esm/vs/editor/common/model/wordHelper.js*/
define("3af5c49",function(e,n){"use strict";function r(e){void 0===e&&(e="");for(var r="(-?\\d*\\.\\d\\w*)|([^",t=0,i=n.USUAL_WORD_SEPARATORS;t<i.length;t++){var a=i[t];e.indexOf(a)>=0||(r+="\\"+a)}return r+="\\s]+)",new RegExp(r,"g")}function t(e){var r=n.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)r=e;else{var t="g";e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.unicode&&(t+="u"),r=new RegExp(e.source,t)}return r.lastIndex=0,r}function i(e,n,r,t){var i=e-1-t,a=r.lastIndexOf(" ",i-1)+1;n.lastIndex=a;for(var d;d=n.exec(r);){var l=d.index||0;if(i>=l&&n.lastIndex>=i)return{word:d[0],startColumn:t+1+l,endColumn:t+1+n.lastIndex}}return null}function a(e,n,r,t){var i=e-1-t;n.lastIndex=0;for(var a;a=n.exec(r);){var d=a.index||0;if(d>i)return null;if(n.lastIndex>=i)return{word:a[0],startColumn:t+1+d,endColumn:t+1+n.lastIndex}}return null}function d(e,n,r,t){n.lastIndex=0;var d=n.exec(r);if(!d)return null;var l=d[0].indexOf(" ")>=0?a(e,n,r,t):i(e,n,r,t);return n.lastIndex=0,l}Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",n.DEFAULT_WORD_REGEXP=r(),n.ensureValidWordDefinition=t,n.getWordAtText=d});
/**! node_modules/monaco-editor/esm/vs/editor/common/model/mirrorTextModel.js*/
define("6250482",function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;var n=e("5ddf902"),i=e("cf86ba2"),s=function(){function e(e,t,n,i){this._uri=e,this._lines=t,this._eol=n,this._versionId=i,this._lineStarts=null}return e.prototype.dispose=function(){this._lines.length=0},e.prototype.getText=function(){return this._lines.join(this._eol)},e.prototype.onEvents=function(e){e.eol&&e.eol!==this._eol&&(this._eol=e.eol,this._lineStarts=null);for(var t=e.changes,i=0,s=t;i<s.length;i++){var r=s[i];this._acceptDeleteRange(r.range),this._acceptInsertText(new n.Position(r.range.startLineNumber,r.range.startColumn),r.text)}this._versionId=e.versionId},e.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var e=this._eol.length,t=this._lines.length,n=new Uint32Array(t),s=0;t>s;s++)n[s]=this._lines[s].length+e;this._lineStarts=new i.PrefixSumComputer(n)}},e.prototype._setLineText=function(e,t){this._lines[e]=t,this._lineStarts&&this._lineStarts.changeValue(e,this._lines[e].length+this._eol.length)},e.prototype._acceptDeleteRange=function(e){if(e.startLineNumber===e.endLineNumber){if(e.startColumn===e.endColumn)return;return void this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.startLineNumber-1].substring(e.endColumn-1))}this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.endLineNumber-1].substring(e.endColumn-1)),this._lines.splice(e.startLineNumber,e.endLineNumber-e.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(e.startLineNumber,e.endLineNumber-e.startLineNumber)},e.prototype._acceptInsertText=function(e,t){if(0!==t.length){var n=t.split(/\r\n|\r|\n/);if(1===n.length)return void this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]+this._lines[e.lineNumber-1].substring(e.column-1));n[n.length-1]+=this._lines[e.lineNumber-1].substring(e.column-1),this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]);for(var i=new Uint32Array(n.length-1),s=1;s<n.length;s++)this._lines.splice(e.lineNumber+s-1,0,n[s]),i[s-1]=n[s].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(e.lineNumber,i)}},e}();t.MirrorTextModel=s});
/**! node_modules/monaco-editor/esm/vs/editor/common/diff/diffComputer.js*/
define("d327c41",function(i,t){"use strict";function e(i,t,e,n){var r=new o.LcsDiff(i,t,e);return r.ComputeDiff(n)}function n(i){if(i.length<=1)return i;for(var t=[i[0]],e=t[0],n=1,r=i.length;r>n;n++){var o=i[n],a=o.originalStart-(e.originalStart+e.originalLength),h=o.modifiedStart-(e.modifiedStart+e.modifiedLength),s=Math.min(a,h);u>s?(e.originalLength=o.originalStart+o.originalLength-e.originalStart,e.modifiedLength=o.modifiedStart+o.modifiedLength-e.modifiedStart):(t.push(o),e=o)}return t}Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=void 0;var r=i("11ed2ab"),o=i("e1c5605"),a=r.__importStar(i("572f899")),h=5e3,u=3,s=function(){function i(t){for(var e=[],n=[],r=0,o=t.length;o>r;r++)e[r]=i._getFirstNonBlankColumn(t[r],1),n[r]=i._getLastNonBlankColumn(t[r],1);this._lines=t,this._startColumns=e,this._endColumns=n}return i.prototype.getLength=function(){return this._lines.length},i.prototype.getElementAtIndex=function(i){return this._lines[i].substring(this._startColumns[i]-1,this._endColumns[i]-1)},i.prototype.getStartLineNumber=function(i){return i+1},i.prototype.getEndLineNumber=function(i){return i+1},i._getFirstNonBlankColumn=function(i,t){var e=a.firstNonWhitespaceIndex(i);return-1===e?t:e+1},i._getLastNonBlankColumn=function(i,t){var e=a.lastNonWhitespaceIndex(i);return-1===e?t:e+2},i.prototype.getCharSequence=function(i,t,e){for(var n=[],r=[],o=[],a=0,h=t;e>=h;h++)for(var u=this._lines[h],s=i?this._startColumns[h]:1,m=i?this._endColumns[h]:u.length+1,g=s;m>g;g++)n[a]=u.charCodeAt(g-1),r[a]=h+1,o[a]=g,a++;return new d(n,r,o)},i}(),d=function(){function i(i,t,e){this._charCodes=i,this._lineNumbers=t,this._columns=e}return i.prototype.getLength=function(){return this._charCodes.length},i.prototype.getElementAtIndex=function(i){return this._charCodes[i]},i.prototype.getStartLineNumber=function(i){return this._lineNumbers[i]},i.prototype.getStartColumn=function(i){return this._columns[i]},i.prototype.getEndLineNumber=function(i){return this._lineNumbers[i]},i.prototype.getEndColumn=function(i){return this._columns[i]+1},i}(),m=function(){function i(i,t,e,n,r,o,a,h){this.originalStartLineNumber=i,this.originalStartColumn=t,this.originalEndLineNumber=e,this.originalEndColumn=n,this.modifiedStartLineNumber=r,this.modifiedStartColumn=o,this.modifiedEndLineNumber=a,this.modifiedEndColumn=h}return i.createFromDiffChange=function(t,e,n){var r,o,a,h,u,s,d,m;return 0===t.originalLength?(r=0,o=0,a=0,h=0):(r=e.getStartLineNumber(t.originalStart),o=e.getStartColumn(t.originalStart),a=e.getEndLineNumber(t.originalStart+t.originalLength-1),h=e.getEndColumn(t.originalStart+t.originalLength-1)),0===t.modifiedLength?(u=0,s=0,d=0,m=0):(u=n.getStartLineNumber(t.modifiedStart),s=n.getStartColumn(t.modifiedStart),d=n.getEndLineNumber(t.modifiedStart+t.modifiedLength-1),m=n.getEndColumn(t.modifiedStart+t.modifiedLength-1)),new i(r,o,a,h,u,s,d,m)},i}(),g=function(){function i(i,t,e,n,r){this.originalStartLineNumber=i,this.originalEndLineNumber=t,this.modifiedStartLineNumber=e,this.modifiedEndLineNumber=n,this.charChanges=r}return i.createFromDiffResult=function(t,r,o,a,h,u,s){var d,g,l,f,c=void 0;if(0===r.originalLength?(d=o.getStartLineNumber(r.originalStart)-1,g=0):(d=o.getStartLineNumber(r.originalStart),g=o.getEndLineNumber(r.originalStart+r.originalLength-1)),0===r.modifiedLength?(l=a.getStartLineNumber(r.modifiedStart)-1,f=0):(l=a.getStartLineNumber(r.modifiedStart),f=a.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),u&&0!==r.originalLength&&0!==r.modifiedLength&&h()){var C=o.getCharSequence(t,r.originalStart,r.originalStart+r.originalLength-1),L=a.getCharSequence(t,r.modifiedStart,r.modifiedStart+r.modifiedLength-1),p=e(C,L,h,!0);s&&(p=n(p)),c=[];for(var S=0,N=p.length;N>S;S++)c.push(m.createFromDiffChange(p[S],C,L))}return new i(d,g,l,f,c)},i}(),l=function(){function i(i,t,e){this.shouldComputeCharChanges=e.shouldComputeCharChanges,this.shouldPostProcessCharChanges=e.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=e.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=e.shouldMakePrettyDiff,this.maximumRunTimeMs=h,this.originalLines=i,this.modifiedLines=t,this.original=new s(i),this.modified=new s(t)}return i.prototype.computeDiff=function(){if(1===this.original.getLength()&&0===this.original.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.getLength(),charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];if(1===this.modified.getLength()&&0===this.modified.getElementAtIndex(0).length)return[{originalStartLineNumber:1,originalEndLineNumber:this.original.getLength(),modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}];this.computationStartTime=(new Date).getTime();var i=e(this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldMakePrettyDiff);if(this.shouldIgnoreTrimWhitespace){for(var t=[],n=0,r=i.length;r>n;n++)t.push(g.createFromDiffResult(this.shouldIgnoreTrimWhitespace,i[n],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return t}for(var o=[],a=0,h=0,n=-1,u=i.length;u>n;n++){for(var d=u>n+1?i[n+1]:null,m=d?d.originalStart:this.originalLines.length,l=d?d.modifiedStart:this.modifiedLines.length;m>a&&l>h;){var f=this.originalLines[a],c=this.modifiedLines[h];if(f!==c){for(var C=s._getFirstNonBlankColumn(f,1),L=s._getFirstNonBlankColumn(c,1);C>1&&L>1;){var p=f.charCodeAt(C-2),S=c.charCodeAt(L-2);if(p!==S)break;C--,L--}(C>1||L>1)&&this._pushTrimWhitespaceCharChange(o,a+1,1,C,h+1,1,L);for(var N=s._getLastNonBlankColumn(f,1),b=s._getLastNonBlankColumn(c,1),_=f.length+1,E=c.length+1;_>N&&E>b;){var p=f.charCodeAt(N-1),S=f.charCodeAt(b-1);if(p!==S)break;N++,b++}(_>N||E>b)&&this._pushTrimWhitespaceCharChange(o,a+1,N,_,h+1,b,E)}a++,h++}d&&(o.push(g.createFromDiffResult(this.shouldIgnoreTrimWhitespace,d,this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),a+=d.originalLength,h+=d.modifiedLength)}return o},i.prototype._pushTrimWhitespaceCharChange=function(i,t,e,n,r,o,a){if(!this._mergeTrimWhitespaceCharChange(i,t,e,n,r,o,a)){var h=void 0;this.shouldComputeCharChanges&&(h=[new m(t,e,t,n,r,o,r,a)]),i.push(new g(t,t,r,r,h))}},i.prototype._mergeTrimWhitespaceCharChange=function(i,t,e,n,r,o,a){var h=i.length;if(0===h)return!1;var u=i[h-1];return 0===u.originalEndLineNumber||0===u.modifiedEndLineNumber?!1:u.originalEndLineNumber+1===t&&u.modifiedEndLineNumber+1===r?(u.originalEndLineNumber=t,u.modifiedEndLineNumber=r,this.shouldComputeCharChanges&&u.charChanges.push(new m(t,e,t,n,r,o,r,a)),!0):!1},i.prototype._continueProcessingPredicate=function(){if(0===this.maximumRunTimeMs)return!0;var i=(new Date).getTime();return i-this.computationStartTime<this.maximumRunTimeMs},i}();t.DiffComputer=l});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/range.js*/
define("4661130",function(n,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;var t=n("5ddf902"),r=function(){function n(n,e,t,r){n>t||n===t&&e>r?(this.startLineNumber=t,this.startColumn=r,this.endLineNumber=n,this.endColumn=e):(this.startLineNumber=n,this.startColumn=e,this.endLineNumber=t,this.endColumn=r)}return n.prototype.isEmpty=function(){return n.isEmpty(this)},n.isEmpty=function(n){return n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn},n.prototype.containsPosition=function(e){return n.containsPosition(this,e)},n.containsPosition=function(n,e){return e.lineNumber<n.startLineNumber||e.lineNumber>n.endLineNumber?!1:e.lineNumber===n.startLineNumber&&e.column<n.startColumn?!1:e.lineNumber===n.endLineNumber&&e.column>n.endColumn?!1:!0},n.prototype.containsRange=function(e){return n.containsRange(this,e)},n.containsRange=function(n,e){return e.startLineNumber<n.startLineNumber||e.endLineNumber<n.startLineNumber?!1:e.startLineNumber>n.endLineNumber||e.endLineNumber>n.endLineNumber?!1:e.startLineNumber===n.startLineNumber&&e.startColumn<n.startColumn?!1:e.endLineNumber===n.endLineNumber&&e.endColumn>n.endColumn?!1:!0},n.prototype.plusRange=function(e){return n.plusRange(this,e)},n.plusRange=function(e,t){var r,u,i,m;return t.startLineNumber<e.startLineNumber?(r=t.startLineNumber,u=t.startColumn):t.startLineNumber===e.startLineNumber?(r=t.startLineNumber,u=Math.min(t.startColumn,e.startColumn)):(r=e.startLineNumber,u=e.startColumn),t.endLineNumber>e.endLineNumber?(i=t.endLineNumber,m=t.endColumn):t.endLineNumber===e.endLineNumber?(i=t.endLineNumber,m=Math.max(t.endColumn,e.endColumn)):(i=e.endLineNumber,m=e.endColumn),new n(r,u,i,m)},n.prototype.intersectRanges=function(e){return n.intersectRanges(this,e)},n.intersectRanges=function(e,t){var r=e.startLineNumber,u=e.startColumn,i=e.endLineNumber,m=e.endColumn,o=t.startLineNumber,s=t.startColumn,a=t.endLineNumber,b=t.endColumn;return o>r?(r=o,u=s):r===o&&(u=Math.max(u,s)),i>a?(i=a,m=b):i===a&&(m=Math.min(m,b)),r>i?null:r===i&&u>m?null:new n(r,u,i,m)},n.prototype.equalsRange=function(e){return n.equalsRange(this,e)},n.equalsRange=function(n,e){return!!n&&!!e&&n.startLineNumber===e.startLineNumber&&n.startColumn===e.startColumn&&n.endLineNumber===e.endLineNumber&&n.endColumn===e.endColumn},n.prototype.getEndPosition=function(){return new t.Position(this.endLineNumber,this.endColumn)},n.prototype.getStartPosition=function(){return new t.Position(this.startLineNumber,this.startColumn)},n.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},n.prototype.setEndPosition=function(e,t){return new n(this.startLineNumber,this.startColumn,e,t)},n.prototype.setStartPosition=function(e,t){return new n(e,t,this.endLineNumber,this.endColumn)},n.prototype.collapseToStart=function(){return n.collapseToStart(this)},n.collapseToStart=function(e){return new n(e.startLineNumber,e.startColumn,e.startLineNumber,e.startColumn)},n.fromPositions=function(e,t){return void 0===t&&(t=e),new n(e.lineNumber,e.column,t.lineNumber,t.column)},n.lift=function(e){return e?new n(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn):null},n.isIRange=function(n){return n&&"number"==typeof n.startLineNumber&&"number"==typeof n.startColumn&&"number"==typeof n.endLineNumber&&"number"==typeof n.endColumn},n.areIntersectingOrTouching=function(n,e){return n.endLineNumber<e.startLineNumber||n.endLineNumber===e.startLineNumber&&n.endColumn<e.startColumn?!1:e.endLineNumber<n.startLineNumber||e.endLineNumber===n.startLineNumber&&e.endColumn<n.startColumn?!1:!0},n.areIntersecting=function(n,e){return n.endLineNumber<e.startLineNumber||n.endLineNumber===e.startLineNumber&&n.endColumn<=e.startColumn?!1:e.endLineNumber<n.startLineNumber||e.endLineNumber===n.startLineNumber&&e.endColumn<=n.startColumn?!1:!0},n.compareRangesUsingStarts=function(n,e){if(n&&e){var t=0|n.startLineNumber,r=0|e.startLineNumber;if(t===r){var u=0|n.startColumn,i=0|e.startColumn;if(u===i){var m=0|n.endLineNumber,o=0|e.endLineNumber;if(m===o){var s=0|n.endColumn,a=0|e.endColumn;return s-a}return m-o}return u-i}return t-r}var b=n?1:0,N=e?1:0;return b-N},n.compareRangesUsingEnds=function(n,e){return n.endLineNumber===e.endLineNumber?n.endColumn===e.endColumn?n.startLineNumber===e.startLineNumber?n.startColumn-e.startColumn:n.startLineNumber-e.startLineNumber:n.endColumn-e.endColumn:n.endLineNumber-e.endLineNumber},n.spansMultipleLines=function(n){return n.endLineNumber>n.startLineNumber},n}();e.Range=r});
/**! node_modules/monaco-editor/esm/vs/editor/common/core/position.js*/
define("5ddf902",function(e,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;var i=function(){function e(e,n){this.lineNumber=e,this.column=n}return e.prototype.with=function(n,i){return void 0===n&&(n=this.lineNumber),void 0===i&&(i=this.column),n===this.lineNumber&&i===this.column?this:new e(n,i)},e.prototype.delta=function(e,n){return void 0===e&&(e=0),void 0===n&&(n=0),this.with(this.lineNumber+e,this.column+n)},e.prototype.equals=function(n){return e.equals(this,n)},e.equals=function(e,n){return e||n?!!e&&!!n&&e.lineNumber===n.lineNumber&&e.column===n.column:!0},e.prototype.isBefore=function(n){return e.isBefore(this,n)},e.isBefore=function(e,n){return e.lineNumber<n.lineNumber?!0:n.lineNumber<e.lineNumber?!1:e.column<n.column},e.prototype.isBeforeOrEqual=function(n){return e.isBeforeOrEqual(this,n)},e.isBeforeOrEqual=function(e,n){return e.lineNumber<n.lineNumber?!0:n.lineNumber<e.lineNumber?!1:e.column<=n.column},e.compare=function(e,n){var i=0|e.lineNumber,u=0|n.lineNumber;if(i===u){var t=0|e.column,r=0|n.column;return t-r}return i-u},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(n){return new e(n.lineNumber,n.column)},e.isIPosition=function(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column},e}();n.Position=i});
/**! node_modules/monaco-editor/esm/vs/base/common/uri.js*/
define("50db2b4",function(t,e){"use strict";function r(t,e){if(!t.scheme){if(e||y)throw new Error('[UriError]: Scheme is missing: {scheme: "", authority: "'+t.authority+'", path: "'+t.path+'", query: "'+t.query+'", fragment: "'+t.fragment+'"}');console.warn('[UriError]: Scheme is missing: {scheme: "", authority: "'+t.authority+'", path: "'+t.path+'", query: "'+t.query+'", fragment: "'+t.fragment+'"}')}if(t.scheme&&!p.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path)if(t.authority){if(!d.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(m.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}function n(t,e){return e||y?t||l:(t||(console.trace("BAD uri lacks scheme, falling back to file-scheme."),t="file"),t)}function i(t,e){switch(t){case"https":case"http":case"file":e?e[0]!==g&&(e=g+e):e=g}return e}function o(t,e){for(var r=void 0,n=-1,i=0;i<t.length;i++){var o=t.charCodeAt(i);if(o>=97&&122>=o||o>=65&&90>=o||o>=48&&57>=o||45===o||46===o||95===o||126===o||e&&47===o)-1!==n&&(r+=encodeURIComponent(t.substring(n,i)),n=-1),void 0!==r&&(r+=t.charAt(i));else{void 0===r&&(r=t.substr(0,i));var h=C[o];void 0!==h?(-1!==n&&(r+=encodeURIComponent(t.substring(n,i)),n=-1),r+=h):-1===n&&(n=i)}}return-1!==n&&(r+=encodeURIComponent(t.substring(n))),void 0!==r?r:t}function h(t){for(var e=void 0,r=0;r<t.length;r++){var n=t.charCodeAt(r);35===n||63===n?(void 0===e&&(e=t.substr(0,r)),e+=C[n]):void 0!==e&&(e+=t[r])}return void 0!==e?e:t}function s(t){var e;return e=t.authority&&t.path.length>1&&"file"===t.scheme?"//"+t.authority+t.path:47===t.path.charCodeAt(0)&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&58===t.path.charCodeAt(2)?t.path[1].toLowerCase()+t.path.substr(2):t.path,c.isWindows&&(e=e.replace(/\//g,"\\")),e}function a(t,e){var r=e?h:o,n="",i=t.scheme,s=t.authority,a=t.path,u=t.query,f=t.fragment;if(i&&(n+=i,n+=":"),(s||"file"===i)&&(n+=g,n+=g),s){var c=s.indexOf("@");if(-1!==c){var p=s.substr(0,c);s=s.substr(c+1),c=p.indexOf(":"),-1===c?n+=r(p,!1):(n+=r(p.substr(0,c),!1),n+=":",n+=r(p.substr(c+1),!1)),n+="@"}s=s.toLowerCase(),c=s.indexOf(":"),-1===c?n+=r(s,!1):(n+=r(s.substr(0,c),!1),n+=s.substr(c))}if(a){if(a.length>=3&&47===a.charCodeAt(0)&&58===a.charCodeAt(2)){var d=a.charCodeAt(1);d>=65&&90>=d&&(a="/"+String.fromCharCode(d+32)+":"+a.substr(3))}else if(a.length>=2&&58===a.charCodeAt(1)){var d=a.charCodeAt(0);d>=65&&90>=d&&(a=String.fromCharCode(d+32)+":"+a.substr(2))}n+=r(a,!0)}return u&&(n+="?",n+=r(u,!1)),f&&(n+="#",n+=e?f:o(f,!1)),n}Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0;var u,f=this&&this.__extends||function(){var t=function(e,r){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])})(e,r)};return function(e,r){function n(){this.constructor=e}t(e,r),e.prototype=null===r?Object.create(r):(n.prototype=r.prototype,new n)}}(),c=t("17c8d25"),p=/^\w[\w\d+.-]*$/,d=/^\//,m=/^\/\//,y=!0,l="",g="/",v=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,b=function(){function t(t,e,o,h,s,a){void 0===a&&(a=!1),"object"==typeof t?(this.scheme=t.scheme||l,this.authority=t.authority||l,this.path=t.path||l,this.query=t.query||l,this.fragment=t.fragment||l):(this.scheme=n(t,a),this.authority=e||l,this.path=i(this.scheme,o||l),this.query=h||l,this.fragment=s||l,r(this,a))}return t.isUri=function(e){return e instanceof t?!0:e?"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString:!1},Object.defineProperty(t.prototype,"fsPath",{get:function(){return s(this)},enumerable:!0,configurable:!0}),t.prototype.with=function(t){if(!t)return this;var e=t.scheme,r=t.authority,n=t.path,i=t.query,o=t.fragment;return void 0===e?e=this.scheme:null===e&&(e=l),void 0===r?r=this.authority:null===r&&(r=l),void 0===n?n=this.path:null===n&&(n=l),void 0===i?i=this.query:null===i&&(i=l),void 0===o?o=this.fragment:null===o&&(o=l),e===this.scheme&&r===this.authority&&n===this.path&&i===this.query&&o===this.fragment?this:new w(e,r,n,i,o)},t.parse=function(t,e){void 0===e&&(e=!1);var r=v.exec(t);return r?new w(r[2]||l,decodeURIComponent(r[4]||l),decodeURIComponent(r[5]||l),decodeURIComponent(r[7]||l),decodeURIComponent(r[9]||l),e):new w(l,l,l,l,l)},t.file=function(t){var e=l;if(c.isWindows&&(t=t.replace(/\\/g,g)),t[0]===g&&t[1]===g){var r=t.indexOf(g,2);-1===r?(e=t.substring(2),t=g):(e=t.substring(2,r),t=t.substring(r)||g)}return new w("file",e,t,l,l)},t.from=function(t){return new w(t.scheme,t.authority,t.path,t.query,t.fragment)},t.prototype.toString=function(t){return void 0===t&&(t=!1),a(this,t)},t.prototype.toJSON=function(){return this},t.revive=function(e){if(e){if(e instanceof t)return e;var r=new w(e);return r._fsPath=e.fsPath,r._formatted=e.external,r}return e},t}();e.URI=b;var w=function(t){function e(){var e=null!==t&&t.apply(this,arguments)||this;return e._formatted=null,e._fsPath=null,e}return f(e,t),Object.defineProperty(e.prototype,"fsPath",{get:function(){return this._fsPath||(this._fsPath=s(this)),this._fsPath},enumerable:!0,configurable:!0}),e.prototype.toString=function(t){return void 0===t&&(t=!1),t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)},e.prototype.toJSON=function(){var t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t},e}(b),C=(u={},u[58]="%3A",u[47]="%2F",u[63]="%3F",u[35]="%23",u[91]="%5B",u[93]="%5D",u[64]="%40",u[33]="%21",u[36]="%24",u[38]="%26",u[39]="%27",u[40]="%28",u[41]="%29",u[42]="%2A",u[43]="%2B",u[44]="%2C",u[59]="%3B",u[61]="%3D",u[32]="%20",u)});
/**! node_modules/monaco-editor/esm/vs/base/common/platform.js*/
define("17c8d25",function(e,i){"use strict";function s(e){return null===c&&(c=i.globals.setImmediate?i.globals.setImmediate.bind(i.globals):i.globals.setTimeout.bind(i.globals)),c(e)}Object.defineProperty(i,"__esModule",{value:!0}),i.OS=i.setImmediate=i.globals=i.isWeb=i.isNative=i.isLinux=i.isMacintosh=i.isWindows=void 0;var a="en",t=!1,o=!1,n=!1,l=!1,d=!1,b=void 0,g=a,r=!1;if("object"!=typeof navigator||r);else{var u=navigator.userAgent;t=u.indexOf("Windows")>=0,o=u.indexOf("Macintosh")>=0,n=u.indexOf("Linux")>=0,d=!0,b=navigator.language,g=b}var f=0;l&&(o?f=1:t?f=3:n&&(f=2)),i.isWindows=t,i.isMacintosh=o,i.isLinux=n,i.isNative=l,i.isWeb=d;var v="object"==typeof self?self:"object"==typeof global?global:{};i.globals=v;var c=null;i.setImmediate=s,i.OS=o?2:t?1:3});
/**! node_modules/monaco-editor/esm/vs/base/common/iterator.js*/
define("6ad26fe",function(t,r){"use strict";function n(t){return Array.isArray(t)?r.Iterator.fromArray(t):t}Object.defineProperty(r,"__esModule",{value:!0}),r.MappedIterator=r.ArrayNavigator=r.ArrayIterator=r.getSequenceIterator=r.Iterator=r.FIN=void 0;var e=this&&this.__extends||function(){var t=function(r,n){return(t=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,r){t.__proto__=r}||function(t,r){for(var n in r)r.hasOwnProperty(n)&&(t[n]=r[n])})(r,n)};return function(r,n){function e(){this.constructor=r}t(r,n),r.prototype=null===n?Object.create(n):(e.prototype=n.prototype,new e)}}();r.FIN={done:!0,value:void 0},function(t){function n(){return s}function e(t,n,e){return void 0===n&&(n=0),void 0===e&&(e=t.length),{next:function(){return n>=e?r.FIN:{done:!1,value:t[n++]}}}}function o(r){return r?Array.isArray(r)?t.fromArray(r):r:t.empty()}function i(t,n){return{next:function(){var e=t.next();return e.done?r.FIN:{done:!1,value:n(e.value)}}}}function u(t,n){return{next:function(){for(;;){var e=t.next();if(e.done)return r.FIN;if(n(e.value))return{done:!1,value:e.value}}}}}function a(t,r){for(var n=t.next();!n.done;n=t.next())r(n.value)}function c(t){var r=[];return a(t,function(t){return r.push(t)}),r}var s={next:function(){return r.FIN}};t.empty=n,t.fromArray=e,t.from=o,t.map=i,t.filter=u,t.forEach=a,t.collect=c}(r.Iterator||(r.Iterator={})),r.getSequenceIterator=n;var o=function(){function t(t,r,n,e){void 0===r&&(r=0),void 0===n&&(n=t.length),void 0===e&&(e=r-1),this.items=t,this.start=r,this.end=n,this.index=e}return t.prototype.next=function(){return this.index=Math.min(this.index+1,this.end),this.current()},t.prototype.current=function(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]},t}();r.ArrayIterator=o;var i=function(t){function r(r,n,e,o){return void 0===n&&(n=0),void 0===e&&(e=r.length),void 0===o&&(o=n-1),t.call(this,r,n,e,o)||this}return e(r,t),r.prototype.current=function(){return t.prototype.current.call(this)},r.prototype.previous=function(){return this.index=Math.max(this.index-1,this.start-1),this.current()},r.prototype.first=function(){return this.index=this.start,this.current()},r.prototype.last=function(){return this.index=this.end-1,this.current()},r.prototype.parent=function(){return null},r}(o);r.ArrayNavigator=i;var u=function(){function t(t,r){this.iterator=t,this.fn=r}return t.prototype.next=function(){return this.fn(this.iterator.next())},t}();r.MappedIterator=u});
/**! node_modules/monaco-editor/esm/vs/base/common/diff/diff.js*/
define("e1c5605",function(t,i){"use strict";function e(t){return{getLength:function(){return t.length},getElementAtIndex:function(i){return t.charCodeAt(i)}}}function n(t,i,n){return new d(e(t),e(i)).ComputeDiff(n)}Object.defineProperty(i,"__esModule",{value:!0}),i.LcsDiff=i.MyArray=i.Debug=i.stringDiff=void 0;var r=t("a895ddf");i.stringDiff=n;var o=function(){function t(){}return t.Assert=function(t,i){if(!t)throw new Error(i)},t}();i.Debug=o;var a=function(){function t(){}return t.Copy=function(t,i,e,n,r){for(var o=0;r>o;o++)e[n+o]=t[i+o]},t}();i.MyArray=a;var h=1447,s=function(){function t(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return t.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new r.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},t.prototype.AddOriginalElement=function(t,i){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,i),this.m_originalCount++},t.prototype.AddModifiedElement=function(t,i){this.m_originalStart=Math.min(this.m_originalStart,t),this.m_modifiedStart=Math.min(this.m_modifiedStart,i),this.m_modifiedCount++},t.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},t.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},t}(),d=function(){function t(t,i,e){void 0===e&&(e=null),this.OriginalSequence=t,this.ModifiedSequence=i,this.ContinueProcessingPredicate=e,this.m_forwardHistory=[],this.m_reverseHistory=[]}return t.prototype.ElementsAreEqual=function(t,i){return this.OriginalSequence.getElementAtIndex(t)===this.ModifiedSequence.getElementAtIndex(i)},t.prototype.OriginalElementsAreEqual=function(t,i){return this.OriginalSequence.getElementAtIndex(t)===this.OriginalSequence.getElementAtIndex(i)},t.prototype.ModifiedElementsAreEqual=function(t,i){return this.ModifiedSequence.getElementAtIndex(t)===this.ModifiedSequence.getElementAtIndex(i)},t.prototype.ComputeDiff=function(t){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1,t)},t.prototype._ComputeDiff=function(t,i,e,n,r){var o=[!1],a=this.ComputeDiffRecursive(t,i,e,n,o);return r?this.PrettifyChanges(a):a},t.prototype.ComputeDiffRecursive=function(t,i,e,n,a){for(a[0]=!1;i>=t&&n>=e&&this.ElementsAreEqual(t,e);)t++,e++;for(;i>=t&&n>=e&&this.ElementsAreEqual(i,n);)i--,n--;if(t>i||e>n){var h=void 0;return n>=e?(o.Assert(t===i+1,"originalStart should only be one more than originalEnd"),h=[new r.DiffChange(t,0,e,n-e+1)]):i>=t?(o.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),h=[new r.DiffChange(t,i-t+1,e,0)]):(o.Assert(t===i+1,"originalStart should only be one more than originalEnd"),o.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}var s=[0],d=[0],g=this.ComputeRecursionPoint(t,i,e,n,s,d,a),f=s[0],u=d[0];if(null!==g)return g;if(!a[0]){var l=this.ComputeDiffRecursive(t,f,e,u,a),m=[];return m=a[0]?[new r.DiffChange(f+1,i-(f+1)+1,u+1,n-(u+1)+1)]:this.ComputeDiffRecursive(f+1,i,u+1,n,a),this.ConcatenateChanges(l,m)}return[new r.DiffChange(t,i-t+1,e,n-e+1)]},t.prototype.WALKTRACE=function(t,i,e,n,o,a,h,d,g,f,u,l,m,c,p,y,C,S){var _,A=null,v=null,E=new s,L=i,M=e,q=m[0]-y[0]-n,D=Number.MIN_VALUE,O=this.m_forwardHistory.length-1;do _=q+t,_===L||M>_&&g[_-1]<g[_+1]?(u=g[_+1],c=u-q-n,D>u&&E.MarkNextChange(),D=u,E.AddModifiedElement(u+1,c),q=_+1-t):(u=g[_-1]+1,c=u-q-n,D>u&&E.MarkNextChange(),D=u-1,E.AddOriginalElement(u,c+1),q=_-1-t),O>=0&&(g=this.m_forwardHistory[O],t=g[0],L=1,M=g.length-1);while(--O>=-1);if(A=E.getReverseChanges(),S[0]){var w=m[0]+1,I=y[0]+1;if(null!==A&&A.length>0){var b=A[A.length-1];w=Math.max(w,b.getOriginalEnd()),I=Math.max(I,b.getModifiedEnd())}v=[new r.DiffChange(w,l-w+1,I,p-I+1)]}else{E=new s,L=a,M=h,q=m[0]-y[0]-d,D=Number.MAX_VALUE,O=C?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do _=q+o,_===L||M>_&&f[_-1]>=f[_+1]?(u=f[_+1]-1,c=u-q-d,u>D&&E.MarkNextChange(),D=u+1,E.AddOriginalElement(u+1,c+1),q=_+1-o):(u=f[_-1],c=u-q-d,u>D&&E.MarkNextChange(),D=u,E.AddModifiedElement(u+1,c+1),q=_-1-o),O>=0&&(f=this.m_reverseHistory[O],o=f[0],L=1,M=f.length-1);while(--O>=-1);v=E.getChanges()}return this.ConcatenateChanges(A,v)},t.prototype.ComputeRecursionPoint=function(t,i,e,n,o,s,d){var g,f=0,u=0,l=0,m=0,c=0,p=0;t--,e--,o[0]=0,s[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var y=i-t+(n-e),C=y+1,S=new Array(C),_=new Array(C),A=n-e,v=i-t,E=t-e,L=i-n,M=v-A,q=M%2===0;S[A]=t,_[v]=i,d[0]=!1;var D,O;for(g=1;y/2+1>=g;g++){var w=0,I=0;for(l=this.ClipDiagonalBound(A-g,g,A,C),m=this.ClipDiagonalBound(A+g,g,A,C),D=l;m>=D;D+=2){for(f=D===l||m>D&&S[D-1]<S[D+1]?S[D+1]:S[D-1]+1,u=f-(D-A)-E,O=f;i>f&&n>u&&this.ElementsAreEqual(f+1,u+1);)f++,u++;if(S[D]=f,f+u>w+I&&(w=f,I=u),!q&&Math.abs(D-v)<=g-1&&f>=_[D])return o[0]=f,s[0]=u,O<=_[D]&&h>0&&h+1>=g?this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,i,o,u,n,s,q,d):null}var b=(w-t+(I-e)-g)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(w,this.OriginalSequence,b))return d[0]=!0,o[0]=w,s[0]=I,b>0&&h>0&&h+1>=g?this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,i,o,u,n,s,q,d):(t++,e++,[new r.DiffChange(t,i-t+1,e,n-e+1)]);for(c=this.ClipDiagonalBound(v-g,g,v,C),p=this.ClipDiagonalBound(v+g,g,v,C),D=c;p>=D;D+=2){for(f=D===c||p>D&&_[D-1]>=_[D+1]?_[D+1]-1:_[D-1],u=f-(D-v)-L,O=f;f>t&&u>e&&this.ElementsAreEqual(f,u);)f--,u--;if(_[D]=f,q&&Math.abs(D-A)<=g&&f<=S[D])return o[0]=f,s[0]=u,O>=S[D]&&h>0&&h+1>=g?this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,i,o,u,n,s,q,d):null}if(h>=g){var B=new Array(m-l+2);B[0]=A-l+1,a.Copy(S,l,B,1,m-l+1),this.m_forwardHistory.push(B),B=new Array(p-c+2),B[0]=v-c+1,a.Copy(_,c,B,1,p-c+1),this.m_reverseHistory.push(B)}}return this.WALKTRACE(A,l,m,E,v,c,p,L,S,_,f,i,o,u,n,s,q,d)},t.prototype.PrettifyChanges=function(t){for(var i=0;i<t.length;i++){for(var e=t[i],n=i<t.length-1?t[i+1].originalStart:this.OriginalSequence.getLength(),r=i<t.length-1?t[i+1].modifiedStart:this.ModifiedSequence.getLength(),o=e.originalLength>0,a=e.modifiedLength>0;e.originalStart+e.originalLength<n&&e.modifiedStart+e.modifiedLength<r&&(!o||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!a||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));)e.originalStart++,e.modifiedStart++;var h=[null];i<t.length-1&&this.ChangesOverlap(t[i],t[i+1],h)&&(t[i]=h[0],t.splice(i+1,1),i--)}for(var i=t.length-1;i>=0;i--){var e=t[i],n=0,r=0;if(i>0){var s=t[i-1];s.originalLength>0&&(n=s.originalStart+s.originalLength),s.modifiedLength>0&&(r=s.modifiedStart+s.modifiedLength)}for(var o=e.originalLength>0,a=e.modifiedLength>0,d=0,g=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength),f=1;;f++){var u=e.originalStart-f,l=e.modifiedStart-f;if(n>u||r>l)break;if(o&&!this.OriginalElementsAreEqual(u,u+e.originalLength))break;if(a&&!this.ModifiedElementsAreEqual(l,l+e.modifiedLength))break;var m=this._boundaryScore(u,e.originalLength,l,e.modifiedLength);m>g&&(g=m,d=f)}e.originalStart-=d,e.modifiedStart-=d}return t},t.prototype._OriginalIsBoundary=function(t){if(0>=t||t>=this.OriginalSequence.getLength()-1)return!0;var i=this.OriginalSequence.getElementAtIndex(t);return"string"==typeof i&&/^\s*$/.test(i)},t.prototype._OriginalRegionIsBoundary=function(t,i){if(this._OriginalIsBoundary(t)||this._OriginalIsBoundary(t-1))return!0;if(i>0){var e=t+i;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1},t.prototype._ModifiedIsBoundary=function(t){if(0>=t||t>=this.ModifiedSequence.getLength()-1)return!0;var i=this.ModifiedSequence.getElementAtIndex(t);return"string"==typeof i&&/^\s*$/.test(i)},t.prototype._ModifiedRegionIsBoundary=function(t,i){if(this._ModifiedIsBoundary(t)||this._ModifiedIsBoundary(t-1))return!0;if(i>0){var e=t+i;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1},t.prototype._boundaryScore=function(t,i,e,n){var r=this._OriginalRegionIsBoundary(t,i)?1:0,o=this._ModifiedRegionIsBoundary(e,n)?1:0;return r+o},t.prototype.ConcatenateChanges=function(t,i){var e=[];if(0===t.length||0===i.length)return i.length>0?i:t;if(this.ChangesOverlap(t[t.length-1],i[0],e)){var n=new Array(t.length+i.length-1);return a.Copy(t,0,n,0,t.length-1),n[t.length-1]=e[0],a.Copy(i,1,n,t.length,i.length-1),n}var n=new Array(t.length+i.length);return a.Copy(t,0,n,0,t.length),a.Copy(i,0,n,t.length,i.length),n},t.prototype.ChangesOverlap=function(t,i,e){if(o.Assert(t.originalStart<=i.originalStart,"Left change is not less than or equal to right change"),o.Assert(t.modifiedStart<=i.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=i.originalStart||t.modifiedStart+t.modifiedLength>=i.modifiedStart){var n=t.originalStart,a=t.originalLength,h=t.modifiedStart,s=t.modifiedLength;return t.originalStart+t.originalLength>=i.originalStart&&(a=i.originalStart+i.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=i.modifiedStart&&(s=i.modifiedStart+i.modifiedLength-t.modifiedStart),e[0]=new r.DiffChange(n,a,h,s),!0}return e[0]=null,!1},t.prototype.ClipDiagonalBound=function(t,i,e,n){if(t>=0&&n>t)return t;var r=e,o=n-e-1,a=i%2===0;if(0>t){var h=r%2===0;return a===h?0:1}var s=o%2===0;return a===s?n-1:n-2},t}();i.LcsDiff=d});
/**! node_modules/monaco-editor/esm/vs/base/common/arrays.js*/
define("2e30c88",function(r,n){"use strict";function t(r,n){return void 0===n&&(n=0),r[r.length-(1+n)]}function e(r){if(0===r.length)throw new Error("Invalid tail call");return[r.slice(0,r.length-1),r[r.length-1]]}function i(r,n,t){if(void 0===t&&(t=function(r,n){return r===n}),r===n)return!0;if(!r||!n)return!1;if(r.length!==n.length)return!1;for(var e=0,i=r.length;i>e;e++)if(!t(r[e],n[e]))return!1;return!0}function u(r,n,t){for(var e=0,i=r.length-1;i>=e;){var u=(e+i)/2|0,a=t(r[u],n);if(0>a)e=u+1;else{if(!(a>0))return u;i=u-1}}return-(e+1)}function a(r,n){var t=0,e=r.length;if(0===e)return 0;for(;e>t;){var i=Math.floor((t+e)/2);n(r[i])?e=i:t=i+1}return t}function f(r,n){return c(r,n,0,r.length-1,[]),r}function o(r,n,t,e,i,u){for(var a=t,f=e+1,o=t;i>=o;o++)u[o]=r[o];for(var o=t;i>=o;o++)r[o]=a>e?u[f++]:f>i?u[a++]:n(u[f],u[a])<0?u[f++]:u[a++]}function c(r,n,t,e,i){if(!(t>=e)){var u=t+(e-t)/2|0;c(r,n,t,u,i),c(r,n,u+1,e,i),n(r[u],r[u+1])<=0||o(r,n,t,u,e,i)}}function s(r,n){for(var t=[],e=void 0,i=0,u=f(r.slice(0),n);i<u.length;i++){var a=u[i];e&&0===n(e[0],a)?e.push(a):(e=[a],t.push(e))}return t}function l(r){return r?r.filter(function(r){return!!r}):r}function v(r){return!Array.isArray(r)||0===r.length}function h(r){return Array.isArray(r)&&r.length>0}function d(r,n){if(!n)return r.filter(function(n,t){return r.indexOf(n)===t});var t=Object.create(null);return r.filter(function(r){var e=n(r);return t[e]?!1:(t[e]=!0,!0)})}function y(r){var n=new Set;return r.filter(function(r){return n.has(r)?!1:(n.add(r),!0)})}function p(r,n){for(var t=0;t<r.length;t++){var e=r[t];if(n(e))return t}return-1}function g(r,n,t){void 0===t&&(t=void 0);var e=p(r,n);return 0>e?t:r[e]}function S(r){var n;return(n=[]).concat.apply(n,r)}function A(r,n){var t="number"==typeof n?r:0;"number"==typeof n?t=r:(t=0,n=r);var e=[];if(n>=t)for(var i=t;n>i;i++)e.push(i);else for(var i=t;i>n;i--)e.push(i);return e}function m(r,n,t){var e=r.slice(0,n),i=r.slice(n);return e.concat(t,i)}function E(r,n){var t=r.indexOf(n);t>-1&&(r.splice(t,1),r.unshift(n))}function I(r,n){var t=r.indexOf(n);t>-1&&(r.splice(t,1),r.push(n))}function O(r){return Array.isArray(r)?r:[r]}Object.defineProperty(n,"__esModule",{value:!0}),n.asArray=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.flatten=n.first=n.firstIndex=n.distinctES6=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesce=n.groupBy=n.mergeSort=n.findFirstInSorted=n.binarySearch=n.equals=n.tail2=n.tail=void 0,n.tail=t,n.tail2=e,n.equals=i,n.binarySearch=u,n.findFirstInSorted=a,n.mergeSort=f,n.groupBy=s,n.coalesce=l,n.isFalsyOrEmpty=v,n.isNonEmptyArray=h,n.distinct=d,n.distinctES6=y,n.firstIndex=p,n.first=g,n.flatten=S,n.range=A,n.arrayInsert=m,n.pushToStart=E,n.pushToEnd=I,n.asArray=O});
/**! node_modules/monaco-editor/esm/vs/base/common/types.js*/
define("01fef85",function(n,t){"use strict";function e(n){return Array.isArray?Array.isArray(n):n&&typeof n.length===b.number&&n.constructor===Array?!0:!1}function r(n){return typeof n===b.string||n instanceof String?!0:!1}function i(n){return!(typeof n!==b.object||null===n||Array.isArray(n)||n instanceof RegExp||n instanceof Date)}function o(n){return(typeof n===b.number||n instanceof Number)&&!isNaN(n)?!0:!1}function u(n){return n===!0||n===!1}function f(n){return typeof n===b.undefined}function s(n){return f(n)||null===n}function a(n){if(!i(n))return!1;for(var t in n)if(m.call(n,t))return!1;return!0}function c(n){return typeof n===b.function}function l(n,t){for(var e=Math.min(n.length,t.length),r=0;e>r;r++)d(n[r],t[r])}function d(n,t){if(r(t)){if(typeof n!==t)throw new Error("argument does not match constraint: typeof "+t)}else if(c(t)){try{if(n instanceof t)return}catch(e){}if(!s(n)&&n.constructor===t)return;if(1===t.length&&t.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function y(n){for(var t=[],e=Object.getPrototypeOf(n);Object.prototype!==e;)t=t.concat(Object.getOwnPropertyNames(e)),e=Object.getPrototypeOf(e);return t}function p(n){return null===n?void 0:n}function g(n){return"undefined"==typeof n?null:n}Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.isFunction=t.isEmptyObject=t.isUndefinedOrNull=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isString=t.isArray=void 0;var b={number:"number",string:"string",undefined:"undefined",object:"object","function":"function"};t.isArray=e,t.isString=r,t.isObject=i,t.isNumber=o,t.isBoolean=u,t.isUndefined=f,t.isUndefinedOrNull=s;var m=Object.prototype.hasOwnProperty;t.isEmptyObject=a,t.isFunction=c,t.validateConstraints=l,t.validateConstraint=d,t.getAllPropertyNames=y,t.withNullAsUndefined=p,t.withUndefinedAsNull=g});
/**! node_modules/monaco-editor/esm/vs/base/common/platform.js*/
define("17c8d25",function(e,i){"use strict";function s(e){return null===c&&(c=i.globals.setImmediate?i.globals.setImmediate.bind(i.globals):i.globals.setTimeout.bind(i.globals)),c(e)}Object.defineProperty(i,"__esModule",{value:!0}),i.OS=i.setImmediate=i.globals=i.isWeb=i.isNative=i.isLinux=i.isMacintosh=i.isWindows=void 0;var a="en",t=!1,o=!1,n=!1,l=!1,d=!1,b=void 0,g=a,r=!1;if("object"!=typeof navigator||r);else{var u=navigator.userAgent;t=u.indexOf("Windows")>=0,o=u.indexOf("Macintosh")>=0,n=u.indexOf("Linux")>=0,d=!0,b=navigator.language,g=b}var f=0;l&&(o?f=1:t?f=3:n&&(f=2)),i.isWindows=t,i.isMacintosh=o,i.isLinux=n,i.isNative=l,i.isWeb=d;var v="object"==typeof self?self:"object"==typeof global?global:{};i.globals=v;var c=null;i.setImmediate=s,i.OS=o?2:t?1:3});
/**! node_modules/monaco-editor/esm/vs/base/common/lifecycle.js*/
define("a0b8cca",function(e,s){"use strict";function o(e){return"function"==typeof e.dispose&&0===e.dispose.length}function i(e){for(var s=[],o=1;o<arguments.length;o++)s[o-1]=arguments[o];return Array.isArray(e)?(e.forEach(function(e){return e&&e.dispose()}),[]):0===s.length?e?(e.dispose(),e):void 0:(i(e),i(s),[])}function t(e){return{dispose:function(){return i(e)}}}function n(e){return{dispose:function(){e()}}}Object.defineProperty(s,"__esModule",{value:!0}),s.ImmortalReference=s.Disposable=s.toDisposable=s.combinedDisposable=s.dispose=s.isDisposable=void 0,s.isDisposable=o,s.dispose=i,s.combinedDisposable=t,s.toDisposable=n;var r=function(){function e(){this._toDispose=[],this._lifecycle_disposable_isDisposed=!1}return e.prototype.dispose=function(){this._lifecycle_disposable_isDisposed=!0,this._toDispose=i(this._toDispose)},e.prototype._register=function(e){return this._lifecycle_disposable_isDisposed?(console.warn("Registering disposable on object that has already been disposed."),e.dispose()):this._toDispose.push(e),e},e.None=Object.freeze({dispose:function(){}}),e}();s.Disposable=r;var p=function(){function e(e){this.object=e}return e.prototype.dispose=function(){},e}();s.ImmortalReference=p});
/**! node_modules/monaco-editor/esm/vs/base/common/errors.js*/
define("22e50b6",function(r,e){"use strict";function n(r){return void(a(r)||e.errorHandler.onUnexpectedError(r))}function t(r){return void(a(r)||e.errorHandler.onUnexpectedExternalError(r))}function o(r){if(r instanceof Error){var e=r.name,n=r.message,t=r.stacktrace||r.stack;return{$isError:!0,name:e,message:n,stack:t}}return r}function a(r){return r instanceof Error&&r.name===u&&r.message===u}function i(){var r=new Error(u);return r.name=r.message,r}function l(r){return new Error(r?"Illegal argument: "+r:"Illegal argument")}function c(r){return new Error(r?"Illegal state: "+r:"Illegal state")}Object.defineProperty(e,"__esModule",{value:!0}),e.illegalState=e.illegalArgument=e.canceled=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.errorHandler=e.ErrorHandler=void 0;var s=function(){function r(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(function(){if(r.stack)throw new Error(r.message+"\n\n"+r.stack);throw r},0)}}return r.prototype.emit=function(r){this.listeners.forEach(function(e){e(r)})},r.prototype.onUnexpectedError=function(r){this.unexpectedErrorHandler(r),this.emit(r)},r.prototype.onUnexpectedExternalError=function(r){this.unexpectedErrorHandler(r)},r}();e.ErrorHandler=s,e.errorHandler=new s,e.onUnexpectedError=n,e.onUnexpectedExternalError=t,e.transformErrorForSerialization=o;var u="Canceled";e.isPromiseCanceledError=a,e.canceled=i,e.illegalArgument=l,e.illegalState=c});
/**! node_modules/monaco-editor/esm/vs/editor/common/services/editorSimpleWorker.js*/
define("0854f85",function(e,t){"use strict";function n(){return new y(null)}Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorkerImpl=t.BaseEditorSimpleWorker=void 0;var r=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}(),o=e("2e30c88"),i=e("e1c5605"),u=e("6ad26fe"),s=e("17c8d25"),l=e("50db2b4"),a=e("5ddf902"),m=e("4661130"),d=e("d327c41"),c=e("6250482"),f=e("3af5c49"),g=e("fabf684"),p=e("670df80"),h=e("4dc9450"),v=e("01fef85"),_=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return r(t,e),Object.defineProperty(t.prototype,"uri",{get:function(){return this._uri},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"eol",{get:function(){return this._eol},enumerable:!0,configurable:!0}),t.prototype.getValue=function(){return this.getText()},t.prototype.getLinesContent=function(){return this._lines.slice(0)},t.prototype.getLineCount=function(){return this._lines.length},t.prototype.getLineContent=function(e){return this._lines[e-1]},t.prototype.getWordAtPosition=function(e,t){var n=f.getWordAtText(e.column,f.ensureValidWordDefinition(t),this._lines[e.lineNumber-1],0);return n?new m.Range(e.lineNumber,n.startColumn,e.lineNumber,n.endColumn):null},t.prototype.getWordUntilPosition=function(e,t){var n=this.getWordAtPosition(e,t);return n?{word:this._lines[e.lineNumber-1].substring(n.startColumn-1,e.column-1),startColumn:n.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},t.prototype.createWordIterator=function(e){var t,n,r=this,o=0,i=0,s=[],l=function(){if(i<s.length){var a=n.substring(s[i].start,s[i].end);return i+=1,t?t.value=a:t={done:!1,value:a},t}return o>=r._lines.length?u.FIN:(n=r._lines[o],s=r._wordenize(n,e),i=0,o+=1,l())};return{next:l}},t.prototype.getLineWords=function(e,t){for(var n=this._lines[e-1],r=this._wordenize(n,t),o=[],i=0,u=r;i<u.length;i++){var s=u[i];o.push({word:n.substring(s.start,s.end),startColumn:s.start+1,endColumn:s.end+1})}return o},t.prototype._wordenize=function(e,t){var n,r=[];for(t.lastIndex=0;(n=t.exec(e))&&0!==n[0].length;)r.push({start:n.index,end:n.index+n[0].length});return r},t.prototype.getValueInRange=function(e){if(e=this._validateRange(e),e.startLineNumber===e.endLineNumber)return this._lines[e.startLineNumber-1].substring(e.startColumn-1,e.endColumn-1);var t=this._eol,n=e.startLineNumber-1,r=e.endLineNumber-1,o=[];o.push(this._lines[n].substring(e.startColumn-1));for(var i=n+1;r>i;i++)o.push(this._lines[i]);return o.push(this._lines[r].substring(0,e.endColumn-1)),o.join(t)},t.prototype.offsetAt=function(e){return e=this._validatePosition(e),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(e.lineNumber-2)+(e.column-1)},t.prototype.positionAt=function(e){e=Math.floor(e),e=Math.max(0,e),this._ensureLineStarts();var t=this._lineStarts.getIndexOf(e),n=this._lines[t.index].length;return{lineNumber:1+t.index,column:1+Math.min(t.remainder,n)}},t.prototype._validateRange=function(e){var t=this._validatePosition({lineNumber:e.startLineNumber,column:e.startColumn}),n=this._validatePosition({lineNumber:e.endLineNumber,column:e.endColumn});return t.lineNumber!==e.startLineNumber||t.column!==e.startColumn||n.lineNumber!==e.endLineNumber||n.column!==e.endColumn?{startLineNumber:t.lineNumber,startColumn:t.column,endLineNumber:n.lineNumber,endColumn:n.column}:e},t.prototype._validatePosition=function(e){if(!a.Position.isIPosition(e))throw new Error("bad position");var t=e.lineNumber,n=e.column,r=!1;if(1>t)t=1,n=1,r=!0;else if(t>this._lines.length)t=this._lines.length,n=this._lines[t-1].length+1,r=!0;else{var o=this._lines[t-1].length+1;1>n?(n=1,r=!0):n>o&&(n=o,r=!0)}return r?{lineNumber:t,column:n}:e},t}(c.MirrorTextModel),b=function(){function e(e){this._foreignModuleFactory=e,this._foreignModule=null}return e.prototype.computeDiff=function(e,t,n){var r=this._getModel(e),o=this._getModel(t);if(!r||!o)return Promise.resolve(null);var i=r.getLinesContent(),u=o.getLinesContent(),s=new d.DiffComputer(i,u,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:n,shouldMakePrettyDiff:!0}),l=s.computeDiff(),a=l.length>0?!1:this._modelsAreIdentical(r,o);return Promise.resolve({identical:a,changes:l})},e.prototype._modelsAreIdentical=function(e,t){var n=e.getLineCount(),r=t.getLineCount();if(n!==r)return!1;for(var o=1;n>=o;o++){var i=e.getLineContent(o),u=t.getLineContent(o);if(i!==u)return!1}return!0},e.prototype.computeMoreMinimalEdits=function(t,n){var r=this._getModel(t);if(!r)return Promise.resolve(n);var u=[],s=void 0;n=o.mergeSort(n,function(e,t){if(e.range&&t.range)return m.Range.compareRangesUsingStarts(e.range,t.range);var n=e.range?0:1,r=t.range?0:1;return n-r});for(var l=0,a=n;l<a.length;l++){var d=a[l],c=d.range,f=d.text,g=d.eol;if("number"==typeof g&&(s=g),!m.Range.isEmpty(c)||f){var p=r.getValueInRange(c);if(f=f.replace(/\r\n|\n|\r/g,r.eol),p!==f)if(Math.max(f.length,p.length)>e._diffLimit)u.push({range:c,text:f});else for(var h=i.stringDiff(p,f,!1),v=r.offsetAt(m.Range.lift(c).getStartPosition()),_=0,b=h;_<b.length;_++){var y=b[_],C=r.positionAt(v+y.originalStart),N=r.positionAt(v+y.originalStart+y.originalLength),L={text:f.substr(y.modifiedStart,y.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:N.lineNumber,endColumn:N.column}};r.getValueInRange(L.range)!==L.text&&u.push(L)}}}return"number"==typeof s&&u.push({eol:s,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),Promise.resolve(u)},e.prototype.computeLinks=function(e){var t=this._getModel(e);return Promise.resolve(t?g.computeLinks(t):null)},e.prototype.textualSuggest=function(t,n,r,o){var i=this._getModel(t);if(!i)return Promise.resolve(null);var u=Object.create(null),s=[],l=new RegExp(r,o),a=i.getWordUntilPosition(n,l),m=i.getWordAtPosition(n,l);m&&(u[i.getValueInRange(m)]=!0);for(var d=i.createWordIterator(l),c=d.next();!c.done&&s.length<=e._suggestionsLimit;c=d.next()){var f=c.value;u[f]||(u[f]=!0,isNaN(Number(f))&&s.push({kind:18,label:f,insertText:f,range:{startLineNumber:n.lineNumber,startColumn:a.startColumn,endLineNumber:n.lineNumber,endColumn:a.endColumn}}))}return Promise.resolve({suggestions:s})},e.prototype.computeWordRanges=function(e,t,n,r){var o=this._getModel(e);if(!o)return Promise.resolve(Object.create(null));for(var i=new RegExp(n,r),u=Object.create(null),s=t.startLineNumber;s<t.endLineNumber;s++)for(var l=o.getLineWords(s,i),a=0,m=l;a<m.length;a++){var d=m[a];if(isNaN(Number(d.word))){var c=u[d.word];c||(c=[],u[d.word]=c),c.push({startLineNumber:s,startColumn:d.startColumn,endLineNumber:s,endColumn:d.endColumn})}}return Promise.resolve(u)},e.prototype.navigateValueSet=function(e,t,n,r,o){var i=this._getModel(e);if(!i)return Promise.resolve(null);var u=new RegExp(r,o);t.startColumn===t.endColumn&&(t={startLineNumber:t.startLineNumber,startColumn:t.startColumn,endLineNumber:t.endLineNumber,endColumn:t.endColumn+1});var s=i.getValueInRange(t),l=i.getWordAtPosition({lineNumber:t.startLineNumber,column:t.startColumn},u);if(!l)return Promise.resolve(null);var a=i.getValueInRange(l),m=p.BasicInplaceReplace.INSTANCE.navigateValueSet(t,s,l,a,n);return Promise.resolve(m)},e.prototype.loadForeignModule=function(e,t){var n=this,r={getMirrorModels:function(){return n._getModels()}};if(this._foreignModuleFactory){this._foreignModule=this._foreignModuleFactory(r,t);for(var o=[],i=0,u=v.getAllPropertyNames(this._foreignModule);i<u.length;i++){var s=u[i];"function"==typeof this._foreignModule[s]&&o.push(s)}return Promise.resolve(o)}return Promise.reject(new Error("Unexpected usage"))},e.prototype.fmr=function(e,t){if(!this._foreignModule||"function"!=typeof this._foreignModule[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this._foreignModule[e].apply(this._foreignModule,t))}catch(n){return Promise.reject(n)}},e._diffLimit=1e5,e._suggestionsLimit=1e4,e}();t.BaseEditorSimpleWorker=b;var y=function(e){function t(t){var n=e.call(this,t)||this;return n._models=Object.create(null),n}return r(t,e),t.prototype.dispose=function(){this._models=Object.create(null)},t.prototype._getModel=function(e){return this._models[e]},t.prototype._getModels=function(){var e=this,t=[];return Object.keys(this._models).forEach(function(n){return t.push(e._models[n])}),t},t.prototype.acceptNewModel=function(e){this._models[e.url]=new _(l.URI.parse(e.url),e.lines,e.EOL,e.versionId)},t.prototype.acceptModelChanged=function(e,t){if(this._models[e]){var n=this._models[e];n.onEvents(t)}},t.prototype.acceptRemovedModel=function(e){this._models[e]&&delete this._models[e]},t}(b);t.EditorSimpleWorkerImpl=y,t.create=n,"function"==typeof importScripts&&(s.globals.monaco=h.createMonacoBaseAPI())});
/**! node_modules/monaco-editor/esm/vs/base/common/worker/simpleWorker.js*/
define("e9bd7e4",function(e,r){"use strict";function t(e){a.isWeb&&(c||(c=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/Microsoft/monaco-editor#faq")),console.warn(e.message))}function n(e){return new p(e,null)}Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.SimpleWorkerServer=r.SimpleWorkerClient=r.logOnceWebWorkerWarning=void 0;var o=this&&this.__extends||function(){var e=function(r,t){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,r){e.__proto__=r}||function(e,r){for(var t in r)r.hasOwnProperty(t)&&(e[t]=r[t])})(r,t)};return function(r,t){function n(){this.constructor=r}e(r,t),r.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}}(),s=e("22e50b6"),i=e("a0b8cca"),a=e("17c8d25"),u=e("01fef85"),l="$initialize",c=!1;r.logOnceWebWorkerWarning=t;var d=function(){function e(e){this._workerId=-1,this._handler=e,this._lastSentReq=0,this._pendingReplies=Object.create(null)}return e.prototype.setWorkerId=function(e){this._workerId=e},e.prototype.sendMessage=function(e,r){var t=this,n=String(++this._lastSentReq);return new Promise(function(o,s){t._pendingReplies[n]={resolve:o,reject:s},t._send({vsWorker:t._workerId,req:n,method:e,args:r})})},e.prototype.handleMessage=function(e){var r;try{r=JSON.parse(e)}catch(t){return}r&&r.vsWorker&&(-1===this._workerId||r.vsWorker===this._workerId)&&this._handleMessage(r)},e.prototype._handleMessage=function(e){var r=this;if(e.seq){var t=e;if(!this._pendingReplies[t.seq])return void console.warn("Got reply to unknown seq");var n=this._pendingReplies[t.seq];if(delete this._pendingReplies[t.seq],t.err){var o=t.err;return t.err.$isError&&(o=new Error,o.name=t.err.name,o.message=t.err.message,o.stack=t.err.stack),void n.reject(o)}return void n.resolve(t.res)}var i=e,a=i.req,u=this._handler.handleMessage(i.method,i.args);u.then(function(e){r._send({vsWorker:r._workerId,seq:a,res:e,err:void 0})},function(e){e.detail instanceof Error&&(e.detail=s.transformErrorForSerialization(e.detail)),r._send({vsWorker:r._workerId,seq:a,res:void 0,err:s.transformErrorForSerialization(e)})})},e.prototype._send=function(e){var r=JSON.stringify(e);this._handler.sendMessage(r)},e}(),f=function(e){function r(r,t){var n=e.call(this)||this,o=null;n._worker=n._register(r.create("vs/base/common/worker/simpleWorker",function(e){n._protocol.handleMessage(e)},function(e){o&&o(e)})),n._protocol=new d({sendMessage:function(e){n._worker.postMessage(e)},handleMessage:function(){return Promise.resolve(null)}}),n._protocol.setWorkerId(n._worker.getId());var s=null;"undefined"!=typeof self.require&&"function"==typeof self.require.getConfig?s=self.require.getConfig():"undefined"!=typeof self.requirejs&&(s=self.requirejs.s.contexts._.config),n._onModuleLoaded=n._protocol.sendMessage(l,[n._worker.getId(),t,s]),n._lazyProxy=new Promise(function(e,r){o=r,n._onModuleLoaded.then(function(r){for(var t={},n=0,o=r;n<o.length;n++){var s=o[n];t[s]=a(s,i)}e(t)},function(e){r(e),n._onError("Worker failed to load "+t,e)})});var i=function(e,r){return n._request(e,r)},a=function(e,r){return function(){var t=Array.prototype.slice.call(arguments,0);return r(e,t)}};return n}return o(r,e),r.prototype.getProxyObject=function(){return this._lazyProxy},r.prototype._request=function(e,r){var t=this;return new Promise(function(n,o){t._onModuleLoaded.then(function(){t._protocol.sendMessage(e,r).then(n,o)},o)})},r.prototype._onError=function(e,r){console.error(e),console.info(r)},r}(i.Disposable);r.SimpleWorkerClient=f;var p=function(){function e(e,r){var t=this;this._requestHandler=r,this._protocol=new d({sendMessage:function(r){e(r)},handleMessage:function(e,r){return t._handleMessage(e,r)}})}return e.prototype.onmessage=function(e){this._protocol.handleMessage(e)},e.prototype._handleMessage=function(e,r){if(e===l)return this.initialize(r[0],r[1],r[2]);if(!this._requestHandler||"function"!=typeof this._requestHandler[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this._requestHandler[e].apply(this._requestHandler,r))}catch(t){return Promise.reject(t)}},e.prototype.initialize=function(e,r,t){var n=this;if(this._protocol.setWorkerId(e),this._requestHandler){for(var o=[],s=0,i=u.getAllPropertyNames(this._requestHandler);s<i.length;s++){var a=i[s];"function"==typeof this._requestHandler[a]&&o.push(a)}return Promise.resolve(o)}return t&&("undefined"!=typeof t.baseUrl&&delete t.baseUrl,"undefined"!=typeof t.paths&&"undefined"!=typeof t.paths.vs&&delete t.paths.vs,t.catchError=!0,self.require.config(t)),new Promise(function(e,t){self.require([r],function(){for(var r=[],o=0;o<arguments.length;o++)r[o]=arguments[o];var s=r[0];if(n._requestHandler=s.create(),!n._requestHandler)return void t(new Error("No RequestHandler!"));for(var i=[],a=0,l=u.getAllPropertyNames(n._requestHandler);a<l.length;a++){var c=l[a];"function"==typeof n._requestHandler[c]&&i.push(c)}e(i)},t)})},e}();r.SimpleWorkerServer=p,r.create=n});
/**! node_modules/monaco-editor/esm/vs/editor/editor.worker.js*/
define("ca932bd",function(e,i){"use strict";function n(e){if(!t){t=!0;var i=new o.EditorSimpleWorkerImpl(e),n=new s.SimpleWorkerServer(function(e){self.postMessage(e)},i);self.onmessage=function(e){n.onmessage(e.data)}}}Object.defineProperty(i,"__esModule",{value:!0}),i.initialize=void 0;var s=e("e9bd7e4"),o=e("0854f85"),t=!1;i.initialize=n,self.onmessage=function(){t||n(null)}});
require('ca932bd')